/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Skeleton implementation for Bison GLR parsers in C

   Copyright (C) 2002-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C GLR parser skeleton written by Paul Hilfinger.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "glr.c"

/* Pure parsers.  */
#define YYPURE 0






/* First part of user declarations.  */

#line 55 "src/parser.cpp" /* glr.c:240  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "src/parser.hpp"

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Default (constant) value used for initialization for null
   right-hand sides.  Unlike the standard yacc.c template, here we set
   the default value of $$ to a zeroed-out value.  Since the default
   value is undefined, this behavior is technically correct.  */
static YYSTYPE yyval_default;
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;

/* Copy the second part of user declarations.  */

#line 88 "src/parser.cpp" /* glr.c:263  */
/* Unqualified %code blocks.  */
#line 6 "src/parser.ypp" /* glr.c:264  */

  #include "src/expression/all.hpp"
  #include "src/statement/all.hpp"
  #include "src/type/all.hpp"

  /**
   * Raw string stack.
   */
  std::stack<std::string> raws;

  /**
   * Push the current raw string onto the stack, and restart it.
   */
  void push_raw() {
    raws.push(raw.str());
    raw.str("");
  }

  /**
   * Pop a raw string from the stack.
   */
  std::string pop_raw() {
    std::string raw = raws.top();
    raws.pop();
    return raw;
  }

  /**
   * Make a location, without documentation string.
   */
  birch::Location* make_loc(YYLTYPE& loc) {
    return new birch::Location(compiler->file, loc.first_line, loc.last_line,
        loc.first_column, loc.last_column);
  }

  /**
   * Make a location, with documentation string.
   */
  birch::Location* make_doc_loc(YYLTYPE& loc) {
    return new birch::Location(compiler->file, loc.first_line, loc.last_line,
        loc.first_column, loc.last_column, pop_raw());
  }

  /**
   * Make an empty name.
   */
  birch::Name* empty_name(YYLTYPE& loc) {
    return new birch::Name();
  }

  /**
   * Make an empty expression.
   */
  birch::Expression* empty_expr(YYLTYPE& loc) {
    return new birch::EmptyExpression(make_loc(loc));
  }

  /**
   * Make an empty statement.
   */
  birch::Statement* empty_stmt(YYLTYPE& loc) {
    return new birch::EmptyStatement(make_loc(loc));
  }

  /**
   * Make an empty type.
   */
  birch::Type* empty_type(YYLTYPE& loc) {
    return new birch::EmptyType(make_loc(loc));
  }

#line 162 "src/parser.cpp" /* glr.c:264  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YYFREE
# define YYFREE free
#endif
#ifndef YYMALLOC
# define YYMALLOC malloc
#endif
#ifndef YYREALLOC
# define YYREALLOC realloc
#endif

#define YYSIZEMAX ((size_t) -1)

#ifdef __cplusplus
   typedef bool yybool;
#else
   typedef unsigned char yybool;
#endif
#define yytrue 1
#define yyfalse 0

#ifndef YYSETJMP
# include <setjmp.h>
# define YYJMP_BUF jmp_buf
# define YYSETJMP(Env) setjmp (Env)
/* Pacify clang.  */
# define YYLONGJMP(Env, Val) (longjmp (Env, Val), YYASSERT (0))
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#ifndef YYASSERT
# define YYASSERT(Condition) ((void) ((Condition) || (abort (), 0)))
#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  42
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   550

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  76
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  141
/* YYNRULES -- Number of rules.  */
#define YYNRULES  287
/* YYNRULES -- Number of states.  */
#define YYNSTATES  492
/* YYMAXRHS -- Maximum number of symbols on right-hand side of rule.  */
#define YYMAXRHS 10
/* YYMAXLEFT -- Maximum number of symbols to the left of a handle
   accessed by $0, $-1, etc., in any rule.  */
#define YYMAXLEFT 0

/* YYTRANSLATE(X) -- Bison symbol number corresponding to X.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   307

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    61,     2,     2,     2,     2,    75,     2,
      53,    54,    64,    62,    59,    63,    60,    65,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    69,    71,
      66,    72,    67,    57,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    55,    58,    56,     2,    70,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    73,     2,    74,    68,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52
};

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   170,   170,   178,   182,   186,   190,   194,   195,   196,
     197,   201,   205,   209,   213,   217,   221,   225,   229,   233,
     234,   235,   236,   237,   238,   239,   240,   244,   245,   249,
     250,   254,   258,   259,   260,   261,   262,   263,   264,   270,
     271,   275,   276,   277,   281,   282,   286,   287,   291,   292,
     296,   297,   301,   302,   306,   307,   308,   309,   318,   319,
     323,   324,   328,   329,   333,   337,   338,   342,   346,   347,
     351,   352,   353,   354,   355,   359,   360,   364,   368,   369,
     373,   374,   378,   382,   383,   387,   391,   392,   396,   397,
     401,   402,   406,   410,   411,   415,   416,   420,   421,   425,
     426,   430,   431,   435,   436,   440,   441,   445,   446,   450,
     454,   455,   459,   460,   464,   465,   469,   473,   474,   483,
     484,   485,   489,   490,   491,   492,   493,   497,   498,   499,
     500,   501,   505,   509,   510,   511,   512,   513,   514,   515,
     519,   523,   524,   528,   532,   532,   536,   537,   538,   539,
     545,   545,   546,   546,   550,   550,   554,   555,   556,   557,
     558,   559,   563,   563,   567,   571,   571,   575,   575,   579,
     579,   583,   583,   587,   588,   589,   590,   591,   595,   595,
     596,   596,   597,   597,   601,   601,   602,   602,   603,   603,
     607,   608,   609,   613,   617,   621,   625,   626,   627,   631,
     635,   639,   645,   646,   650,   654,   658,   662,   666,   670,
     674,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   695,   696,   700,   701,   705,
     706,   707,   708,   709,   710,   711,   715,   716,   720,   721,
     725,   726,   727,   731,   732,   736,   737,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   754,   755,   759,
     760,   764,   768,   772,   773,   777,   778,   782,   786,   787,
     791,   795,   796,   800,   804,   805,   809,   818,   819,   823,
     824,   828,   829,   830,   831,   832,   836,   837
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PROGRAM", "CLASS", "STRUCT", "TYPE",
  "FUNCTION", "OPERATOR", "AUTO", "LET", "IF", "ELSE", "FOR", "IN",
  "WHILE", "DO", "WITH", "ASSERT", "RETURN", "FACTOR", "PHANTOM", "CPP",
  "HPP", "THIS", "SUPER", "GLOBAL", "PARALLEL", "DYNAMIC", "ABSTRACT",
  "OVERRIDE", "FINAL", "ACYCLIC", "NIL", "DOUBLE_BRACE_OPEN",
  "DOUBLE_BRACE_CLOSE", "NAME", "BOOL_LITERAL", "INT_LITERAL",
  "REAL_LITERAL", "STRING_LITERAL", "LEFT_OP", "RIGHT_OP", "LEFT_TILDE_OP",
  "RIGHT_TILDE_OP", "LEFT_QUERY_OP", "AND_OP", "OR_OP", "LE_OP", "GE_OP",
  "EQ_OP", "NE_OP", "RANGE_OP", "'('", "')'", "'['", "']'", "'?'",
  "'\\\\'", "','", "'.'", "'!'", "'+'", "'-'", "'*'", "'/'", "'<'", "'>'",
  "'~'", "':'", "'_'", "';'", "'='", "'{'", "'}'", "'&'", "$accept",
  "name", "bool_literal", "int_literal", "real_literal", "string_literal",
  "literal", "identifier", "parens_expression", "sequence_expression",
  "cast_expression", "function_expression", "this_expression",
  "super_expression", "nil_expression", "primary_expression",
  "slice_expression", "slice_expression_list", "slice",
  "postfix_expression", "query_expression", "prefix_operator",
  "prefix_expression", "multiplicative_operator",
  "multiplicative_expression", "additive_operator", "additive_expression",
  "relational_operator", "relational_expression", "equality_operator",
  "equality_expression", "logical_and_operator", "logical_and_expression",
  "logical_or_operator", "logical_or_expression", "assign_operator",
  "assign_expression", "expression", "optional_expression",
  "expression_list", "span_expression", "span_list", "brackets",
  "parameters", "optional_parameters", "parameter_list", "parameter",
  "options", "option_list", "option", "arguments", "optional_arguments",
  "shape", "generics", "generic_list", "generic", "optional_generics",
  "generic_arguments", "generic_argument_list", "generic_argument",
  "optional_generic_arguments", "init_operator",
  "global_variable_declaration", "member_variable_declaration",
  "member_phantom_declaration", "local_variable_declaration",
  "tuple_variable", "tuple_variables", "tuple_variables_declaration",
  "function_declaration", "$@1", "member_function_annotation",
  "member_function_declaration", "$@2", "$@3", "program_declaration",
  "$@4", "binary_operator", "binary_operator_declaration", "$@5",
  "unary_operator", "unary_operator_declaration", "$@6",
  "assignment_operator_declaration", "$@7",
  "conversion_operator_declaration", "$@8", "slice_operator_declaration",
  "$@9", "class_annotation", "class_declaration", "$@10", "$@11", "$@12",
  "struct_declaration", "$@13", "$@14", "$@15", "basic_declaration", "cpp",
  "hpp", "expression_statement", "if", "for_variable_declaration", "for",
  "parallel_annotation", "parallel", "while", "do_while", "with", "block",
  "assertion", "return", "factor", "statement", "statements",
  "optional_statements", "class_statement", "class_statements",
  "optional_class_statements", "struct_statement", "struct_statements",
  "optional_struct_statements", "file_statement", "file_statements",
  "optional_file_statements", "file", "return_type",
  "optional_return_type", "optional_auto_return_type", "braces",
  "optional_braces", "class_braces", "optional_class_braces",
  "struct_braces", "optional_struct_braces", "double_braces", "named_type",
  "primary_type", "type", "type_list", YY_NULLPTR
};
#endif

#define YYPACT_NINF -356
#define YYTABLE_NINF -261

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const short int yypact[] =
{
     208,    25,    25,    25,    25,    15,    60,    60,  -356,    86,
    -356,  -356,    54,  -356,  -356,  -356,  -356,  -356,   138,  -356,
    -356,  -356,  -356,  -356,   316,  -356,  -356,   149,   109,   113,
     153,    15,    11,  -356,   122,   155,  -356,  -356,  -356,    51,
      25,  -356,  -356,    29,  -356,   -17,    25,  -356,    25,   143,
    -356,  -356,   139,   150,    84,  -356,    51,   152,   162,  -356,
       9,   166,  -356,   172,   191,   187,   -20,   129,    25,  -356,
     181,   177,   178,   212,  -356,    25,  -356,  -356,  -356,   186,
    -356,   483,    25,   216,   203,     6,  -356,   184,    25,  -356,
    -356,   353,   131,  -356,  -356,  -356,  -356,   120,   189,   465,
      -9,    51,  -356,    25,  -356,   424,  -356,  -356,  -356,   210,
     225,  -356,    25,    38,  -356,  -356,    51,  -356,  -356,  -356,
    -356,    51,  -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,
    -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,
      25,   227,   192,    51,  -356,  -356,   218,   229,   215,  -356,
    -356,  -356,  -356,   226,  -356,  -356,  -356,  -356,  -356,   465,
    -356,   465,   143,   223,  -356,  -356,  -356,  -356,  -356,  -356,
    -356,  -356,  -356,  -356,  -356,   232,  -356,  -356,   276,  -356,
     465,  -356,   123,   136,    58,   185,   247,   222,  -356,   235,
     241,   237,  -356,   238,   242,   245,  -356,   234,  -356,   236,
      25,   240,   117,  -356,    25,    66,   465,    25,   465,   239,
     465,   465,   465,   465,   295,  -356,    44,   243,  -356,  -356,
    -356,  -356,  -356,  -356,   282,  -356,  -356,  -356,  -356,  -356,
    -356,  -356,  -356,   424,  -356,   246,  -356,  -356,    25,   254,
     257,  -356,    94,  -356,  -356,   215,   -20,   215,   263,   212,
    -356,  -356,    51,    25,   272,   255,   212,   270,    25,   465,
    -356,    25,  -356,  -356,  -356,  -356,   465,   465,   465,   465,
     465,  -356,  -356,  -356,  -356,  -356,   465,   465,   465,  -356,
     192,   465,  -356,  -356,  -356,  -356,  -356,    25,    79,   465,
      31,    25,    31,   239,  -356,   321,   239,   315,   239,   269,
    -356,   271,   273,    25,    51,  -356,   328,  -356,  -356,  -356,
    -356,  -356,  -356,    25,   274,  -356,  -356,  -356,    94,  -356,
     277,  -356,   212,  -356,  -356,   284,  -356,  -356,  -356,   -20,
     300,  -356,   296,   303,   304,  -356,  -356,   123,   136,    58,
     185,   247,  -356,  -356,  -356,  -356,   289,   257,  -356,   130,
    -356,  -356,  -356,   465,  -356,   302,   308,   465,   352,   465,
    -356,   465,  -356,  -356,  -356,  -356,   356,   412,    25,    38,
     301,    51,  -356,  -356,  -356,   -20,  -356,  -356,   465,   465,
    -356,   465,  -356,  -356,    25,    16,  -356,  -356,   336,  -356,
    -356,   360,  -356,  -356,  -356,  -356,  -356,   130,  -356,   299,
     305,    25,    31,   310,    17,   322,   311,   465,  -356,   124,
     312,   465,   371,  -356,  -356,   413,   -20,  -356,   333,  -356,
    -356,    79,    15,    25,    51,    25,  -356,  -356,    25,  -356,
    -356,  -356,  -356,   465,  -356,  -356,  -356,   465,  -356,   343,
    -356,   329,  -356,   331,   465,  -356,   132,   332,   465,  -356,
    -356,  -356,   143,  -356,   349,   -20,    15,   338,   239,   465,
    -356,  -356,   358,  -356,   346,  -356,   347,   212,   -20,   377,
    -356,   143,  -356,  -356,   239,   465,  -356,  -356,  -356,  -356,
    -356,   212,  -356,   239,   -20,   -20,  -356,  -356,  -356,  -356,
     -20,  -356
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const unsigned short int yydefact[] =
{
     177,     0,     0,     0,     0,   111,     0,     0,   173,   174,
     175,     2,     0,   247,   248,   249,   250,   251,     0,   252,
     253,   254,   255,   256,   177,   259,   261,     0,     0,   111,
       0,   111,     0,   110,     0,     0,   193,   194,   176,     0,
       0,   258,     1,     0,   154,    89,     0,   192,     0,     0,
     105,   109,     0,   107,     0,   276,     0,   118,   279,   281,
       0,   111,    93,     0,     0,    95,     0,     0,     0,    88,
     186,     0,     0,   264,   106,     0,    43,    41,    42,     0,
     164,     0,     0,   286,     0,     0,   117,   277,     0,   119,
     120,     0,     0,   282,   283,   121,   122,     0,     0,     0,
      89,     0,    94,     0,   269,   228,   268,   155,    86,     0,
      90,   188,     0,     0,   190,   191,   266,   263,   265,   144,
     108,     0,    64,    67,    56,    57,    60,    61,    50,    51,
      46,    47,    54,    55,   156,   157,   158,   159,   160,   161,
       0,     0,     0,     0,   280,   112,     0,   114,   116,   278,
     284,    16,    17,     0,    18,     3,     4,     5,     6,     0,
      99,     0,     0,   118,     7,     8,     9,    10,    19,    20,
      21,    22,    23,    24,    25,     0,    26,    32,    39,    44,
       0,    48,    52,    58,    62,    65,    68,    75,    77,    80,
       0,   103,    82,    83,     0,     0,   125,     0,   123,     0,
       0,   180,    97,    96,     0,     0,     0,     0,     0,     0,
       0,     0,    79,    79,     0,   201,   118,     0,   211,   212,
     224,   213,   214,   215,     0,   216,   217,   218,   219,   220,
     221,   222,   223,   225,   227,     0,   207,    87,     0,     0,
     102,   275,   246,   274,   187,   262,     0,    92,     0,   264,
     287,   113,     0,     0,     0,     0,   264,    11,     0,     0,
      40,     0,    38,    36,    37,    45,     0,     0,     0,     0,
       0,    70,    72,    73,    71,    74,     0,     0,     0,   100,
       0,     0,    85,   285,   126,   124,   182,     0,     0,     0,
       0,     0,     0,     0,   199,     0,     0,     0,     0,     0,
      78,     0,     0,     0,     0,   195,     0,   226,   267,    91,
     189,   101,   184,     0,     0,   240,   241,   242,   243,   245,
       0,   145,   264,   165,   115,   118,    34,    12,    13,     0,
       0,    33,    29,     0,    28,    35,    49,    53,    59,    63,
      66,    69,    76,    81,   104,    84,     0,   102,   272,   239,
     271,   181,    98,     0,   140,   141,     0,     0,   198,     0,
     204,     0,   206,   208,   209,   210,     0,     0,     0,     0,
       0,     0,   244,   273,   162,     0,    11,    15,     0,     0,
      31,     0,   183,   178,     0,     0,   146,   148,   147,   229,
     230,     0,   231,   232,   233,   234,   235,   236,   238,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   135,     0,
       0,     0,     0,   185,   132,     0,     0,   166,     0,    30,
      27,     0,   111,     0,     0,     0,   169,   149,     0,   237,
     270,   133,   142,     0,   134,   197,   196,     0,   205,     0,
     138,     0,   136,     0,     0,   127,     0,     0,     0,   163,
      14,   179,     0,   167,     0,     0,   111,     0,     0,     0,
     139,   137,     0,   130,     0,   128,     0,   264,     0,     0,
     170,     0,   143,   200,     0,     0,   131,   129,   152,   168,
     171,   264,   203,     0,     0,     0,   150,   202,   153,   172,
       0,   151
};

  /* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -356,     0,  -356,  -356,  -356,  -356,  -356,   -41,  -356,  -356,
    -356,  -356,  -356,  -356,  -356,  -356,  -356,    41,  -356,  -356,
    -356,   367,  -158,   341,   159,   348,   168,   357,   158,   364,
     160,   366,   182,   285,  -356,  -356,   194,   -79,   262,  -142,
    -356,   195,  -336,   -40,   359,  -228,   -48,  -356,   375,  -356,
     -52,   141,   213,  -356,   417,  -356,   -24,  -356,   244,  -356,
     -42,  -267,  -356,  -311,  -308,  -356,  -356,    93,  -356,  -356,
    -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,
    -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,
    -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,  -356,   -89,
    -221,  -356,    91,  -270,  -356,  -356,  -356,  -356,  -356,  -356,
    -356,  -356,  -356,  -356,  -356,   266,  -356,  -356,   103,  -356,
    -356,   188,  -356,  -356,   484,  -356,  -356,  -355,  -356,  -238,
     -70,  -234,  -356,    88,  -356,   142,   500,   -19,  -356,   -25,
     369
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const short int yydefgoto[] =
{
      -1,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   332,   333,   263,   178,
     179,   180,   181,   266,   182,   267,   183,   268,   184,   269,
     185,   270,   186,   139,   187,   277,   188,   189,   301,   190,
     193,   194,    97,    69,    70,   109,   110,    44,    64,    65,
     311,   312,   195,    33,    52,    53,    34,    86,   146,   147,
     257,    99,    13,   315,   316,   218,   355,   356,   219,    14,
     246,   391,   392,   490,   484,    15,    66,   140,    16,   416,
      82,    17,   375,   393,   468,   394,   455,   395,   485,    18,
      19,   421,   288,   346,    20,   369,   113,   239,    21,    22,
      23,   221,   222,   295,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   397,   398,   399,
     318,   319,   320,    24,    25,    26,    27,   117,   118,   119,
     106,   107,   350,   351,   243,   244,    36,    58,    59,    83,
      84
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const short int yytable[] =
{
      12,    28,    29,    30,    31,    45,    81,    49,    98,    73,
     309,   323,   321,   192,    60,    87,   220,   254,   329,   255,
     199,   317,   265,   353,    12,   357,   217,    71,   206,    72,
     426,   409,    51,   366,   141,   236,    67,   100,   389,    57,
      61,   390,    11,    63,    67,   197,    57,    11,    57,   111,
      89,   104,    90,   105,    79,    68,    57,   423,   424,    56,
     148,    11,    91,   200,    92,    11,    93,    79,    57,   150,
      94,   425,    89,   145,    90,    51,   202,    95,    50,   446,
      96,    32,    79,    62,   374,    57,   389,    11,    57,   390,
     105,   245,   248,   240,    35,   377,   247,   317,   412,    95,
     411,    57,    11,    63,    56,   216,   124,   125,   336,   241,
      85,   242,    57,   304,   480,   313,    57,     7,    38,   291,
      11,    57,   256,    39,   132,   133,   264,   293,   396,   296,
      11,   298,   299,   300,   300,   433,   343,   384,   385,   297,
      79,   417,    40,    57,   220,    76,    77,    78,   448,    42,
     348,   313,   349,     7,   217,   151,   152,   153,   289,   386,
     387,   388,    43,   236,   154,    11,    11,    11,   155,   156,
     157,   158,   142,    91,    93,    54,   396,    91,    94,    32,
     334,   286,   449,   108,   159,    91,   161,   130,   131,   162,
      55,   196,    76,    77,    78,   440,    67,   454,   128,   129,
      57,   191,   192,   463,   290,   292,    74,   294,  -260,    75,
     352,     1,   326,     2,     3,     4,     5,   331,    85,    46,
     335,   470,    88,   358,    47,    48,   360,   148,   362,   478,
       6,     7,    32,   216,   479,   126,   127,     8,    79,     9,
      10,   101,   314,   486,    11,   102,   103,   112,   114,   115,
     488,   489,    57,   325,   116,   121,   491,   144,   325,   149,
     198,   325,   191,   271,   237,   272,   273,   274,   347,   123,
     142,   142,    93,    93,   400,   143,    94,    94,   403,   367,
     405,   249,   406,   376,   238,   251,   253,    57,   252,    85,
     275,   354,   258,   122,   278,   279,   280,   281,   282,   418,
     334,   283,   420,   294,    57,   284,   287,   285,   303,   306,
      91,   328,   105,   370,   305,   410,  -257,   322,   314,     1,
     308,     2,     3,     4,     5,   310,   327,   330,   439,    91,
     361,   259,   443,   260,   436,   359,   261,   262,     6,     7,
     363,   368,   364,   371,   365,     8,   415,     9,    10,   314,
      85,   373,    11,   378,   457,   379,   381,   441,   458,   380,
     382,   401,   402,   447,   404,   462,   427,   428,   294,   466,
     407,    57,   414,   430,   437,   453,   431,   151,   152,   153,
     474,   434,   438,   442,   422,   444,   154,   450,   473,    11,
     155,   156,   157,   158,   464,   459,   483,   314,   452,   245,
     460,   354,   461,   465,   482,   469,   159,   160,   161,   472,
     475,   162,   467,   487,    76,    77,    78,   476,   477,   424,
     419,    80,   134,    79,    57,    79,   337,   339,   456,   135,
     340,   481,   471,   204,   205,   206,   338,   207,   136,   208,
     209,   210,   211,   212,   213,   137,     6,   138,   151,   152,
     153,   214,   215,    89,    89,    90,    90,   154,   341,   201,
      11,   155,   156,   157,   158,    91,    91,    92,    92,    93,
      93,   342,   276,    94,    94,   302,   345,   159,   203,   161,
      95,    95,   162,   408,   445,    76,    77,    78,   383,   151,
     152,   153,   120,   344,   432,   435,   324,   105,   154,   307,
     429,    11,   155,   156,   157,   158,   372,    37,    41,   451,
       0,   413,   250,     0,     0,     0,     0,     0,   159,     0,
     161,     0,     0,   162,     0,     0,    76,    77,    78,   122,
     123,   124,   125,   126,   127,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   128,   129,   130,   131,   132,
     133
};

static const short int yycheck[] =
{
       0,     1,     2,     3,     4,    29,    54,    31,    60,    49,
     238,   249,   246,    92,    39,    57,   105,   159,   256,   161,
      99,   242,   180,   290,    24,   292,   105,    46,    11,    48,
     385,   367,    32,   303,    82,   105,    53,    61,   349,    39,
      40,   349,    36,    43,    53,    97,    46,    36,    48,    68,
      41,    71,    43,    73,    54,    72,    56,    41,    42,    53,
      85,    36,    53,    72,    55,    36,    57,    67,    68,    88,
      61,    55,    41,    67,    43,    75,   101,    68,    67,   415,
      71,    66,    82,    54,   322,    85,   397,    36,    88,   397,
      73,   116,   140,   112,    34,   329,   121,   318,   368,    68,
     367,   101,    36,   103,    53,   105,    48,    49,   266,    71,
      66,    73,   112,    69,   469,    21,   116,    23,    32,    53,
      36,   121,   162,    69,    66,    67,   178,   206,   349,   208,
      36,   210,   211,   212,   213,   402,   278,     7,     8,   209,
     140,   375,     4,   143,   233,    61,    62,    63,   415,     0,
      71,    21,    73,    23,   233,    24,    25,    26,    41,    29,
      30,    31,    53,   233,    33,    36,    36,    36,    37,    38,
      39,    40,    55,    53,    57,    53,   397,    53,    61,    66,
     259,   200,   416,    54,    53,    53,    55,    64,    65,    58,
      35,    71,    61,    62,    63,    71,    53,   425,    62,    63,
     200,    70,   281,    71,   204,   205,    67,   207,     0,    59,
     289,     3,   253,     5,     6,     7,     8,   258,    66,    66,
     261,   455,    60,   293,    71,    72,   296,   252,   298,   467,
      22,    23,    66,   233,   468,    50,    51,    29,   238,    31,
      32,    69,   242,   481,    36,    54,    59,    66,    71,    71,
     484,   485,   252,   253,    42,    69,   490,    54,   258,    75,
      71,   261,    70,    41,    54,    43,    44,    45,   287,    47,
      55,    55,    57,    57,   353,    59,    61,    61,   357,   304,
     359,    54,   361,   325,    59,    67,    60,   287,    59,    66,
      68,   291,    60,    46,    59,    54,    59,    59,    56,   378,
     379,    56,   381,   303,   304,    71,    66,    71,    13,    27,
      53,    56,    73,   313,    71,   367,     0,    54,   318,     3,
      74,     5,     6,     7,     8,    71,    54,    57,   407,    53,
      15,    55,   411,    57,   404,    14,    60,    61,    22,    23,
      71,    13,    71,    69,    71,    29,   371,    31,    32,   349,
      66,    74,    36,    53,   433,    59,    52,   409,   437,    56,
      71,    59,    54,   415,    12,   444,    30,     7,   368,   448,
      14,   371,    71,    74,    52,   423,    71,    24,    25,    26,
     459,    71,    71,    71,   384,    14,    33,    54,   458,    36,
      37,    38,    39,    40,   446,    52,   475,   397,   422,   424,
      71,   401,    71,    71,   474,    56,    53,    54,    55,    71,
      52,    58,   452,   483,    61,    62,    63,    71,    71,    42,
     379,    54,    81,   423,   424,   425,   267,   269,   428,    81,
     270,   471,   456,     9,    10,    11,   268,    13,    81,    15,
      16,    17,    18,    19,    20,    81,    22,    81,    24,    25,
      26,    27,    28,    41,    41,    43,    43,    33,   276,   100,
      36,    37,    38,    39,    40,    53,    53,    55,    55,    57,
      57,   277,   187,    61,    61,   213,   281,    53,   103,    55,
      68,    68,    58,    71,    71,    61,    62,    63,   347,    24,
      25,    26,    75,   280,   401,   404,   252,    73,    33,   233,
     397,    36,    37,    38,    39,    40,   318,     7,    24,   421,
      -1,   369,   143,    -1,    -1,    -1,    -1,    -1,    53,    -1,
      55,    -1,    -1,    58,    -1,    -1,    61,    62,    63,    46,
      47,    48,    49,    50,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    63,    64,    65,    66,
      67
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     5,     6,     7,     8,    22,    23,    29,    31,
      32,    36,    77,   138,   145,   151,   154,   157,   165,   166,
     170,   174,   175,   176,   199,   200,   201,   202,    77,    77,
      77,    77,    66,   129,   132,    34,   212,   212,    32,    69,
       4,   200,     0,    53,   123,   132,    66,    71,    72,   132,
      67,    77,   130,   131,    53,    35,    53,    77,   213,   214,
     215,    77,    54,    77,   124,   125,   152,    53,    72,   119,
     120,   213,   213,   119,    67,    59,    61,    62,    63,    77,
      97,   122,   156,   215,   216,    66,   133,   136,    60,    41,
      43,    53,    55,    57,    61,    68,    71,   118,   126,   137,
     132,    69,    54,    59,    71,    73,   206,   207,    54,   121,
     122,   213,    66,   172,    71,    71,    42,   203,   204,   205,
     130,    69,    46,    47,    48,    49,    50,    51,    62,    63,
      64,    65,    66,    67,    99,   101,   103,   105,   107,   109,
     153,   122,    55,    59,    54,    67,   134,   135,   215,    75,
     213,    24,    25,    26,    33,    37,    38,    39,    40,    53,
      54,    55,    58,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    95,    96,
      97,    98,   100,   102,   104,   106,   108,   110,   112,   113,
     115,    70,   113,   116,   117,   128,    71,   126,    71,   113,
      72,   120,   215,   124,     9,    10,    11,    13,    15,    16,
      17,    18,    19,    20,    27,    28,    77,   113,   141,   144,
     175,   177,   178,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   206,    54,    59,   173,
     213,    71,    73,   210,   211,   215,   146,   215,   122,    54,
     216,    67,    59,    60,   115,   115,   119,   136,    60,    55,
      57,    60,    61,    94,   126,    98,    99,   101,   103,   105,
     107,    41,    43,    44,    45,    68,   109,   111,    59,    54,
      59,    59,    56,    56,    71,    71,   213,    66,   168,    41,
      77,    53,    77,   113,    77,   179,   113,   206,   113,   113,
     113,   114,   114,    13,    69,    71,    27,   191,    74,   121,
      71,   126,   127,    21,    77,   139,   140,   176,   196,   197,
     198,   207,    54,   205,   134,    77,    83,    54,    56,   205,
      57,    83,    92,    93,   113,    83,    98,   100,   102,   104,
     106,   108,   112,   115,   128,   117,   169,   213,    71,    73,
     208,   209,   113,   137,    77,   142,   143,   137,   206,    14,
     206,    15,   206,    71,    71,    71,   179,   215,    13,   171,
      77,    69,   197,    74,   205,   158,   136,   207,    53,    59,
      56,    52,    71,   127,     7,     8,    29,    30,    31,   139,
     140,   147,   148,   159,   161,   163,   176,   193,   194,   195,
     113,    59,    54,   113,    12,   113,   113,    14,    71,   118,
     126,   137,   179,   211,    71,   215,   155,   207,   113,    93,
     113,   167,    77,    41,    42,    55,   203,    30,     7,   194,
      74,    71,   143,   137,    71,   178,   206,    52,    71,   113,
      71,   126,    71,   113,    14,    71,   118,   126,   137,   207,
      54,   209,   132,   122,   121,   162,    77,   113,   113,    52,
      71,    71,   113,    71,   126,    71,   113,   119,   160,    56,
     207,   132,    71,   206,   113,    52,    71,    71,   205,   207,
     203,   119,   206,   113,   150,   164,   205,   206,   207,   207,
     149,   207
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    76,    77,    78,    79,    80,    81,    82,    82,    82,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      91,    91,    91,    91,    91,    91,    91,    92,    92,    93,
      93,    94,    95,    95,    95,    95,    95,    95,    95,    96,
      96,    97,    97,    97,    98,    98,    99,    99,   100,   100,
     101,   101,   102,   102,   103,   103,   103,   103,   104,   104,
     105,   105,   106,   106,   107,   108,   108,   109,   110,   110,
     111,   111,   111,   111,   111,   112,   112,   113,   114,   114,
     115,   115,   116,   117,   117,   118,   119,   119,   120,   120,
     121,   121,   122,   123,   123,   124,   124,   125,   125,   126,
     126,   127,   127,   128,   128,   129,   129,   130,   130,   131,
     132,   132,   133,   133,   134,   134,   135,   136,   136,   137,
     137,   137,   138,   138,   138,   138,   138,   139,   139,   139,
     139,   139,   140,   141,   141,   141,   141,   141,   141,   141,
     142,   143,   143,   144,   146,   145,   147,   147,   147,   147,
     149,   148,   150,   148,   152,   151,   153,   153,   153,   153,
     153,   153,   155,   154,   156,   158,   157,   160,   159,   162,
     161,   164,   163,   165,   165,   165,   165,   165,   167,   166,
     168,   166,   169,   166,   171,   170,   172,   170,   173,   170,
     174,   174,   174,   175,   176,   177,   178,   178,   178,   179,
     180,   181,   182,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   190,   190,   190,   191,   191,   192,   192,   193,
     193,   193,   193,   193,   193,   193,   194,   194,   195,   195,
     196,   196,   196,   197,   197,   198,   198,   199,   199,   199,
     199,   199,   199,   199,   199,   199,   199,   200,   200,   201,
     201,   202,   203,   204,   204,   205,   205,   206,   207,   207,
     208,   209,   209,   210,   211,   211,   212,   213,   213,   214,
     214,   215,   215,   215,   215,   215,   216,   216
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     3,     6,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       3,     3,     1,     3,     3,     3,     2,     2,     2,     1,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     1,     3,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     0,
       1,     3,     1,     1,     3,     3,     2,     3,     1,     0,
       1,     3,     3,     2,     3,     1,     3,     3,     5,     2,
       3,     1,     0,     1,     3,     2,     3,     1,     3,     1,
       1,     0,     2,     3,     1,     3,     1,     1,     0,     1,
       1,     1,     4,     5,     6,     5,     6,     4,     5,     6,
       5,     6,     3,     5,     5,     4,     5,     6,     5,     6,
       1,     1,     3,     7,     0,     7,     1,     1,     1,     2,
       0,     8,     0,     7,     0,     5,     1,     1,     1,     1,
       1,     1,     0,    10,     1,     0,     9,     0,     5,     0,
       4,     0,     7,     1,     1,     1,     2,     0,     0,    10,
       0,     7,     0,     8,     0,     9,     0,     6,     0,     7,
       5,     5,     3,     2,     2,     2,     5,     5,     3,     1,
       7,     1,     9,     8,     3,     5,     3,     1,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     0,
       1,     1,     1,     1,     2,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       0,     1,     2,     1,     0,     1,     1,     3,     1,     1,
       3,     1,     1,     3,     1,     1,     2,     2,     3,     1,
       3,     1,     2,     2,     3,     4,     1,     3
};


/* YYDPREC[RULE-NUM] -- Dynamic precedence of rule #RULE-NUM (0 if none).  */
static const unsigned char yydprec[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     3,     2,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0
};

/* YYMERGER[RULE-NUM] -- Index of merging function for rule #RULE-NUM.  */
static const unsigned char yymerger[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0
};

/* YYIMMEDIATE[RULE-NUM] -- True iff rule #RULE-NUM is not to be deferred, as
   in the case of predicates.  */
static const yybool yyimmediate[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0
};

/* YYCONFLP[YYPACT[STATE-NUM]] -- Pointer into YYCONFL of start of
   list of conflicting reductions corresponding to action entry for
   state STATE-NUM in yytable.  0 means no conflicts.  The list in
   yyconfl is terminated by a rule number of 0.  */
static const unsigned char yyconflp[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       9,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     3,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     5,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     7,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    11,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0
};

/* YYCONFL[I] -- lists of conflicting rule numbers, each terminated by
   0, pointed into by YYCONFLP.  */
static const short int yyconfl[] =
{
       0,   111,     0,   118,     0,   111,     0,   118,     0,   118,
       0,    11,     0,   118,     0
};

/* Error token number */
#define YYTERROR 1


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

# define YYRHSLOC(Rhs, K) ((Rhs)[K].yystate.yyloc)


YYSTYPE yylval;
YYLTYPE yylloc;

int yynerrs;
int yychar;

static const int YYEOF = 0;
static const int YYEMPTY = -2;

typedef enum { yyok, yyaccept, yyabort, yyerr } YYRESULTTAG;

#define YYCHK(YYE)                              \
  do {                                          \
    YYRESULTTAG yychk_flag = YYE;               \
    if (yychk_flag != yyok)                     \
      return yychk_flag;                        \
  } while (0)

#if YYDEBUG

# ifndef YYFPRINTF
#  define YYFPRINTF fprintf
# endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YYDPRINTF(Args)                        \
  do {                                          \
    if (yydebug)                                \
      YYFPRINTF Args;                           \
  } while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                  \
  do {                                                                  \
    if (yydebug)                                                        \
      {                                                                 \
        YYFPRINTF (stderr, "%s ", Title);                               \
        yy_symbol_print (stderr, Type, Value, Location);        \
        YYFPRINTF (stderr, "\n");                                       \
      }                                                                 \
  } while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;

struct yyGLRStack;
static void yypstack (struct yyGLRStack* yystackp, size_t yyk)
  YY_ATTRIBUTE_UNUSED;
static void yypdumpstack (struct yyGLRStack* yystackp)
  YY_ATTRIBUTE_UNUSED;

#else /* !YYDEBUG */

# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)

#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYMAXDEPTH * sizeof (GLRStackItem)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Minimum number of free items on the stack allowed after an
   allocation.  This is to allow allocation and initialization
   to be completed by functions that call yyexpandGLRStack before the
   stack is expanded, thus insuring that all necessary pointers get
   properly redirected to new data.  */
#define YYHEADROOM 2

#ifndef YYSTACKEXPANDABLE
#  define YYSTACKEXPANDABLE 1
#endif

#if YYSTACKEXPANDABLE
# define YY_RESERVE_GLRSTACK(Yystack)                   \
  do {                                                  \
    if (Yystack->yyspaceLeft < YYHEADROOM)              \
      yyexpandGLRStack (Yystack);                       \
  } while (0)
#else
# define YY_RESERVE_GLRSTACK(Yystack)                   \
  do {                                                  \
    if (Yystack->yyspaceLeft < YYHEADROOM)              \
      yyMemoryExhausted (Yystack);                      \
  } while (0)
#endif


#if YYERROR_VERBOSE

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static size_t
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return strlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* !YYERROR_VERBOSE */

/** State numbers, as in LALR(1) machine */
typedef int yyStateNum;

/** Rule numbers, as in LALR(1) machine */
typedef int yyRuleNum;

/** Grammar symbol */
typedef int yySymbol;

/** Item references, as in LALR(1) machine */
typedef short int yyItemNum;

typedef struct yyGLRState yyGLRState;
typedef struct yyGLRStateSet yyGLRStateSet;
typedef struct yySemanticOption yySemanticOption;
typedef union yyGLRStackItem yyGLRStackItem;
typedef struct yyGLRStack yyGLRStack;

struct yyGLRState {
  /** Type tag: always true.  */
  yybool yyisState;
  /** Type tag for yysemantics.  If true, yysval applies, otherwise
   *  yyfirstVal applies.  */
  yybool yyresolved;
  /** Number of corresponding LALR(1) machine state.  */
  yyStateNum yylrState;
  /** Preceding state in this stack */
  yyGLRState* yypred;
  /** Source position of the last token produced by my symbol */
  size_t yyposn;
  union {
    /** First in a chain of alternative reductions producing the
     *  non-terminal corresponding to this state, threaded through
     *  yynext.  */
    yySemanticOption* yyfirstVal;
    /** Semantic value for this state.  */
    YYSTYPE yysval;
  } yysemantics;
  /** Source location for this state.  */
  YYLTYPE yyloc;
};

struct yyGLRStateSet {
  yyGLRState** yystates;
  /** During nondeterministic operation, yylookaheadNeeds tracks which
   *  stacks have actually needed the current lookahead.  During deterministic
   *  operation, yylookaheadNeeds[0] is not maintained since it would merely
   *  duplicate yychar != YYEMPTY.  */
  yybool* yylookaheadNeeds;
  size_t yysize, yycapacity;
};

struct yySemanticOption {
  /** Type tag: always false.  */
  yybool yyisState;
  /** Rule number for this reduction */
  yyRuleNum yyrule;
  /** The last RHS state in the list of states to be reduced.  */
  yyGLRState* yystate;
  /** The lookahead for this reduction.  */
  int yyrawchar;
  YYSTYPE yyval;
  YYLTYPE yyloc;
  /** Next sibling in chain of options.  To facilitate merging,
   *  options are chained in decreasing order by address.  */
  yySemanticOption* yynext;
};

/** Type of the items in the GLR stack.  The yyisState field
 *  indicates which item of the union is valid.  */
union yyGLRStackItem {
  yyGLRState yystate;
  yySemanticOption yyoption;
};

struct yyGLRStack {
  int yyerrState;
  /* To compute the location of the error token.  */
  yyGLRStackItem yyerror_range[3];

  YYJMP_BUF yyexception_buffer;
  yyGLRStackItem* yyitems;
  yyGLRStackItem* yynextFree;
  size_t yyspaceLeft;
  yyGLRState* yysplitPoint;
  yyGLRState* yylastDeleted;
  yyGLRStateSet yytops;
};

#if YYSTACKEXPANDABLE
static void yyexpandGLRStack (yyGLRStack* yystackp);
#endif

static _Noreturn void
yyFail (yyGLRStack* yystackp, const char* yymsg)
{
  if (yymsg != YY_NULLPTR)
    yyerror (yymsg);
  YYLONGJMP (yystackp->yyexception_buffer, 1);
}

static _Noreturn void
yyMemoryExhausted (yyGLRStack* yystackp)
{
  YYLONGJMP (yystackp->yyexception_buffer, 2);
}

#if YYDEBUG || YYERROR_VERBOSE
/** A printable representation of TOKEN.  */
static inline const char*
yytokenName (yySymbol yytoken)
{
  if (yytoken == YYEMPTY)
    return "";

  return yytname[yytoken];
}
#endif

/** Fill in YYVSP[YYLOW1 .. YYLOW0-1] from the chain of states starting
 *  at YYVSP[YYLOW0].yystate.yypred.  Leaves YYVSP[YYLOW1].yystate.yypred
 *  containing the pointer to the next state in the chain.  */
static void yyfillin (yyGLRStackItem *, int, int) YY_ATTRIBUTE_UNUSED;
static void
yyfillin (yyGLRStackItem *yyvsp, int yylow0, int yylow1)
{
  int i;
  yyGLRState *s = yyvsp[yylow0].yystate.yypred;
  for (i = yylow0-1; i >= yylow1; i -= 1)
    {
#if YYDEBUG
      yyvsp[i].yystate.yylrState = s->yylrState;
#endif
      yyvsp[i].yystate.yyresolved = s->yyresolved;
      if (s->yyresolved)
        yyvsp[i].yystate.yysemantics.yysval = s->yysemantics.yysval;
      else
        /* The effect of using yysval or yyloc (in an immediate rule) is
         * undefined.  */
        yyvsp[i].yystate.yysemantics.yyfirstVal = YY_NULLPTR;
      yyvsp[i].yystate.yyloc = s->yyloc;
      s = yyvsp[i].yystate.yypred = s->yypred;
    }
}

/* Do nothing if YYNORMAL or if *YYLOW <= YYLOW1.  Otherwise, fill in
 * YYVSP[YYLOW1 .. *YYLOW-1] as in yyfillin and set *YYLOW = YYLOW1.
 * For convenience, always return YYLOW1.  */
static inline int yyfill (yyGLRStackItem *, int *, int, yybool)
     YY_ATTRIBUTE_UNUSED;
static inline int
yyfill (yyGLRStackItem *yyvsp, int *yylow, int yylow1, yybool yynormal)
{
  if (!yynormal && yylow1 < *yylow)
    {
      yyfillin (yyvsp, *yylow, yylow1);
      *yylow = yylow1;
    }
  return yylow1;
}

/** Perform user action for rule number YYN, with RHS length YYRHSLEN,
 *  and top stack item YYVSP.  YYLVALP points to place to put semantic
 *  value ($$), and yylocp points to place for location information
 *  (@$).  Returns yyok for normal return, yyaccept for YYACCEPT,
 *  yyerr for YYERROR, yyabort for YYABORT.  */
static YYRESULTTAG
yyuserAction (yyRuleNum yyn, size_t yyrhslen, yyGLRStackItem* yyvsp,
              yyGLRStack* yystackp,
              YYSTYPE* yyvalp, YYLTYPE *yylocp)
{
  yybool yynormal YY_ATTRIBUTE_UNUSED = (yystackp->yysplitPoint == YY_NULLPTR);
  int yylow;
  YYUSE (yyvalp);
  YYUSE (yylocp);
  YYUSE (yyrhslen);
# undef yyerrok
# define yyerrok (yystackp->yyerrState = 0)
# undef YYACCEPT
# define YYACCEPT return yyaccept
# undef YYABORT
# define YYABORT return yyabort
# undef YYERROR
# define YYERROR return yyerrok, yyerr
# undef YYRECOVERING
# define YYRECOVERING() (yystackp->yyerrState != 0)
# undef yyclearin
# define yyclearin (yychar = YYEMPTY)
# undef YYFILL
# define YYFILL(N) yyfill (yyvsp, &yylow, N, yynormal)
# undef YYBACKUP
# define YYBACKUP(Token, Value)                                              \
  return yyerror (YY_("syntax error: cannot back up")),     \
         yyerrok, yyerr

  yylow = 1;
  if (yyrhslen == 0)
    *yyvalp = yyval_default;
  else
    *yyvalp = yyvsp[YYFILL (1-yyrhslen)].yystate.yysemantics.yysval;
  YYLLOC_DEFAULT ((*yylocp), (yyvsp - yyrhslen), yyrhslen);
  yystackp->yyerror_range[1].yystate.yyloc = *yylocp;

  switch (yyn)
    {
        case 2:
#line 170 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valString)); }
#line 1490 "src/parser.cpp" /* glr.c:816  */
    break;

  case 3:
#line 178 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Literal<bool>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valString), make_loc((*yylocp))); }
#line 1496 "src/parser.cpp" /* glr.c:816  */
    break;

  case 4:
#line 182 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Literal<int64_t>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valString), make_loc((*yylocp))); }
#line 1502 "src/parser.cpp" /* glr.c:816  */
    break;

  case 5:
#line 186 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Literal<double>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valString), make_loc((*yylocp))); }
#line 1508 "src/parser.cpp" /* glr.c:816  */
    break;

  case 6:
#line 190 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Literal<const char*>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valString), make_loc((*yylocp))); }
#line 1514 "src/parser.cpp" /* glr.c:816  */
    break;

  case 11:
#line 201 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::NamedExpression((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))); }
#line 1520 "src/parser.cpp" /* glr.c:816  */
    break;

  case 12:
#line 205 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Parentheses((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1526 "src/parser.cpp" /* glr.c:816  */
    break;

  case 13:
#line 209 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Sequence((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1532 "src/parser.cpp" /* glr.c:816  */
    break;

  case 14:
#line 213 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Cast(new birch::NamedType((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1538 "src/parser.cpp" /* glr.c:816  */
    break;

  case 15:
#line 217 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::LambdaFunction((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 1544 "src/parser.cpp" /* glr.c:816  */
    break;

  case 16:
#line 221 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::This(make_loc((*yylocp))); }
#line 1550 "src/parser.cpp" /* glr.c:816  */
    break;

  case 17:
#line 225 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Super(make_loc((*yylocp))); }
#line 1556 "src/parser.cpp" /* glr.c:816  */
    break;

  case 18:
#line 229 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Nil(make_loc((*yylocp))); }
#line 1562 "src/parser.cpp" /* glr.c:816  */
    break;

  case 27:
#line 244 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Range((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1568 "src/parser.cpp" /* glr.c:816  */
    break;

  case 30:
#line 250 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::ExpressionList((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1574 "src/parser.cpp" /* glr.c:816  */
    break;

  case 31:
#line 254 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression); }
#line 1580 "src/parser.cpp" /* glr.c:816  */
    break;

  case 33:
#line 259 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Member((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1586 "src/parser.cpp" /* glr.c:816  */
    break;

  case 34:
#line 260 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Global((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1592 "src/parser.cpp" /* glr.c:816  */
    break;

  case 35:
#line 261 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Member((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1598 "src/parser.cpp" /* glr.c:816  */
    break;

  case 36:
#line 262 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Slice((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1604 "src/parser.cpp" /* glr.c:816  */
    break;

  case 37:
#line 263 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Call((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1610 "src/parser.cpp" /* glr.c:816  */
    break;

  case 38:
#line 264 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Get((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1616 "src/parser.cpp" /* glr.c:816  */
    break;

  case 40:
#line 271 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Query((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1622 "src/parser.cpp" /* glr.c:816  */
    break;

  case 41:
#line 275 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("+"); }
#line 1628 "src/parser.cpp" /* glr.c:816  */
    break;

  case 42:
#line 276 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("-"); }
#line 1634 "src/parser.cpp" /* glr.c:816  */
    break;

  case 43:
#line 277 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("!"); }
#line 1640 "src/parser.cpp" /* glr.c:816  */
    break;

  case 45:
#line 282 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::UnaryCall((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1646 "src/parser.cpp" /* glr.c:816  */
    break;

  case 46:
#line 286 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("*"); }
#line 1652 "src/parser.cpp" /* glr.c:816  */
    break;

  case 47:
#line 287 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("/"); }
#line 1658 "src/parser.cpp" /* glr.c:816  */
    break;

  case 49:
#line 292 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::BinaryCall((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1664 "src/parser.cpp" /* glr.c:816  */
    break;

  case 50:
#line 296 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("+"); }
#line 1670 "src/parser.cpp" /* glr.c:816  */
    break;

  case 51:
#line 297 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("-"); }
#line 1676 "src/parser.cpp" /* glr.c:816  */
    break;

  case 53:
#line 302 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::BinaryCall((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1682 "src/parser.cpp" /* glr.c:816  */
    break;

  case 54:
#line 306 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("<"); }
#line 1688 "src/parser.cpp" /* glr.c:816  */
    break;

  case 55:
#line 307 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name(">"); }
#line 1694 "src/parser.cpp" /* glr.c:816  */
    break;

  case 56:
#line 308 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("<="); }
#line 1700 "src/parser.cpp" /* glr.c:816  */
    break;

  case 57:
#line 309 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name(">="); }
#line 1706 "src/parser.cpp" /* glr.c:816  */
    break;

  case 59:
#line 319 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::BinaryCall((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1712 "src/parser.cpp" /* glr.c:816  */
    break;

  case 60:
#line 323 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("=="); }
#line 1718 "src/parser.cpp" /* glr.c:816  */
    break;

  case 61:
#line 324 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("!="); }
#line 1724 "src/parser.cpp" /* glr.c:816  */
    break;

  case 63:
#line 329 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::BinaryCall((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1730 "src/parser.cpp" /* glr.c:816  */
    break;

  case 64:
#line 333 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("&&"); }
#line 1736 "src/parser.cpp" /* glr.c:816  */
    break;

  case 66:
#line 338 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::BinaryCall((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1742 "src/parser.cpp" /* glr.c:816  */
    break;

  case 67:
#line 342 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("||"); }
#line 1748 "src/parser.cpp" /* glr.c:816  */
    break;

  case 69:
#line 347 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::BinaryCall((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1754 "src/parser.cpp" /* glr.c:816  */
    break;

  case 70:
#line 351 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("<-"); }
#line 1760 "src/parser.cpp" /* glr.c:816  */
    break;

  case 71:
#line 352 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("<-?"); }
#line 1766 "src/parser.cpp" /* glr.c:816  */
    break;

  case 72:
#line 353 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("<~"); }
#line 1772 "src/parser.cpp" /* glr.c:816  */
    break;

  case 73:
#line 354 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("~>"); }
#line 1778 "src/parser.cpp" /* glr.c:816  */
    break;

  case 74:
#line 355 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("~"); }
#line 1784 "src/parser.cpp" /* glr.c:816  */
    break;

  case 76:
#line 360 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Assign((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1790 "src/parser.cpp" /* glr.c:816  */
    break;

  case 79:
#line 369 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = empty_expr((*yylocp)); }
#line 1796 "src/parser.cpp" /* glr.c:816  */
    break;

  case 81:
#line 374 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::ExpressionList((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1802 "src/parser.cpp" /* glr.c:816  */
    break;

  case 82:
#line 378 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Span((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1808 "src/parser.cpp" /* glr.c:816  */
    break;

  case 84:
#line 383 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::ExpressionList((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1814 "src/parser.cpp" /* glr.c:816  */
    break;

  case 85:
#line 387 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression); }
#line 1820 "src/parser.cpp" /* glr.c:816  */
    break;

  case 86:
#line 391 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = empty_expr((*yylocp)); }
#line 1826 "src/parser.cpp" /* glr.c:816  */
    break;

  case 87:
#line 392 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression); }
#line 1832 "src/parser.cpp" /* glr.c:816  */
    break;

  case 89:
#line 397 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = empty_expr((*yylocp)); }
#line 1838 "src/parser.cpp" /* glr.c:816  */
    break;

  case 91:
#line 402 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::ExpressionList((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1844 "src/parser.cpp" /* glr.c:816  */
    break;

  case 92:
#line 406 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Parameter(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valType), empty_name((*yylocp)), empty_expr((*yylocp)), make_loc((*yylocp))); }
#line 1850 "src/parser.cpp" /* glr.c:816  */
    break;

  case 93:
#line 410 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = empty_expr((*yylocp)); }
#line 1856 "src/parser.cpp" /* glr.c:816  */
    break;

  case 94:
#line 411 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression); }
#line 1862 "src/parser.cpp" /* glr.c:816  */
    break;

  case 96:
#line 416 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::ExpressionList((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1868 "src/parser.cpp" /* glr.c:816  */
    break;

  case 97:
#line 420 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Parameter(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valType), empty_name((*yylocp)), empty_expr((*yylocp)), make_loc((*yylocp))); }
#line 1874 "src/parser.cpp" /* glr.c:816  */
    break;

  case 98:
#line 421 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Parameter(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), new birch::Name((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valString)), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1880 "src/parser.cpp" /* glr.c:816  */
    break;

  case 99:
#line 425 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = empty_expr((*yylocp)); }
#line 1886 "src/parser.cpp" /* glr.c:816  */
    break;

  case 100:
#line 426 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression); }
#line 1892 "src/parser.cpp" /* glr.c:816  */
    break;

  case 102:
#line 431 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = empty_expr((*yylocp)); }
#line 1898 "src/parser.cpp" /* glr.c:816  */
    break;

  case 103:
#line 435 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valInt) = 1; }
#line 1904 "src/parser.cpp" /* glr.c:816  */
    break;

  case 104:
#line 436 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valInt) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valInt) + 1; }
#line 1910 "src/parser.cpp" /* glr.c:816  */
    break;

  case 105:
#line 440 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = empty_expr((*yylocp)); }
#line 1916 "src/parser.cpp" /* glr.c:816  */
    break;

  case 106:
#line 441 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression); }
#line 1922 "src/parser.cpp" /* glr.c:816  */
    break;

  case 108:
#line 446 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::ExpressionList((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 1928 "src/parser.cpp" /* glr.c:816  */
    break;

  case 109:
#line 450 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = new birch::Generic(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valName), empty_type((*yylocp)), make_loc((*yylocp))); }
#line 1934 "src/parser.cpp" /* glr.c:816  */
    break;

  case 111:
#line 455 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valExpression) = empty_expr((*yylocp)); }
#line 1940 "src/parser.cpp" /* glr.c:816  */
    break;

  case 112:
#line 459 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = empty_type((*yylocp)); }
#line 1946 "src/parser.cpp" /* glr.c:816  */
    break;

  case 113:
#line 460 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType); }
#line 1952 "src/parser.cpp" /* glr.c:816  */
    break;

  case 115:
#line 465 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = new birch::TypeList((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))); }
#line 1958 "src/parser.cpp" /* glr.c:816  */
    break;

  case 118:
#line 474 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = empty_type((*yylocp)); }
#line 1964 "src/parser.cpp" /* glr.c:816  */
    break;

  case 119:
#line 483 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("<-"); }
#line 1970 "src/parser.cpp" /* glr.c:816  */
    break;

  case 120:
#line 484 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("<~"); }
#line 1976 "src/parser.cpp" /* glr.c:816  */
    break;

  case 121:
#line 485 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valName) = new birch::Name("~"); }
#line 1982 "src/parser.cpp" /* glr.c:816  */
    break;

  case 122:
#line 489 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::GlobalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), empty_expr((*yylocp)), empty_expr((*yylocp)), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 1988 "src/parser.cpp" /* glr.c:816  */
    break;

  case 123:
#line 490 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::GlobalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 1994 "src/parser.cpp" /* glr.c:816  */
    break;

  case 124:
#line 491 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::GlobalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valType), empty_expr((*yylocp)), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_doc_loc((*yylocp))); }
#line 2000 "src/parser.cpp" /* glr.c:816  */
    break;

  case 125:
#line 492 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::GlobalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valName), new birch::ArrayType((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression)->width(), make_loc((*yylocp))), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), empty_expr((*yylocp)), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2006 "src/parser.cpp" /* glr.c:816  */
    break;

  case 126:
#line 493 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::GlobalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), new birch::ArrayType((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression)->width(), make_loc((*yylocp))), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2012 "src/parser.cpp" /* glr.c:816  */
    break;

  case 127:
#line 497 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::MemberVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), empty_expr((*yylocp)), empty_expr((*yylocp)), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2018 "src/parser.cpp" /* glr.c:816  */
    break;

  case 128:
#line 498 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::MemberVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2024 "src/parser.cpp" /* glr.c:816  */
    break;

  case 129:
#line 499 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::MemberVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valType), empty_expr((*yylocp)), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_doc_loc((*yylocp))); }
#line 2030 "src/parser.cpp" /* glr.c:816  */
    break;

  case 130:
#line 500 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::MemberVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valName), new birch::ArrayType((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression)->width(), make_loc((*yylocp))), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), empty_expr((*yylocp)), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2036 "src/parser.cpp" /* glr.c:816  */
    break;

  case 131:
#line 501 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::MemberVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), new birch::ArrayType((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression)->width(), make_loc((*yylocp))), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2042 "src/parser.cpp" /* glr.c:816  */
    break;

  case 132:
#line 505 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::MemberPhantom(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), make_doc_loc((*yylocp))); }
#line 2048 "src/parser.cpp" /* glr.c:816  */
    break;

  case 133:
#line 509 "src/parser.ypp" /* glr.c:816  */
    { yywarn("the auto keyword is deprecated, use let instead"); push_raw(); ((*yyvalp).valStatement) = new birch::LocalVariable(birch::LET, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valName), empty_type((*yylocp)), empty_expr((*yylocp)), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_doc_loc((*yylocp))); }
#line 2054 "src/parser.cpp" /* glr.c:816  */
    break;

  case 134:
#line 510 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::LocalVariable(birch::LET, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valName), empty_type((*yylocp)), empty_expr((*yylocp)), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_doc_loc((*yylocp))); }
#line 2060 "src/parser.cpp" /* glr.c:816  */
    break;

  case 135:
#line 511 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::LocalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), empty_expr((*yylocp)), empty_expr((*yylocp)), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2066 "src/parser.cpp" /* glr.c:816  */
    break;

  case 136:
#line 512 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::LocalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2072 "src/parser.cpp" /* glr.c:816  */
    break;

  case 137:
#line 513 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::LocalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valType), empty_expr((*yylocp)), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_doc_loc((*yylocp))); }
#line 2078 "src/parser.cpp" /* glr.c:816  */
    break;

  case 138:
#line 514 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::LocalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valName), new birch::ArrayType((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression)->width(), make_loc((*yylocp))), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), empty_expr((*yylocp)), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2084 "src/parser.cpp" /* glr.c:816  */
    break;

  case 139:
#line 515 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::LocalVariable(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), new birch::ArrayType((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression)->width(), make_loc((*yylocp))), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2090 "src/parser.cpp" /* glr.c:816  */
    break;

  case 140:
#line 519 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::LocalVariable(birch::LET, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valName), empty_type((*yylocp)), empty_expr((*yylocp)), empty_expr((*yylocp)), empty_name((*yylocp)), empty_expr((*yylocp)), make_doc_loc((*yylocp))); }
#line 2096 "src/parser.cpp" /* glr.c:816  */
    break;

  case 142:
#line 524 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::StatementList((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2102 "src/parser.cpp" /* glr.c:816  */
    break;

  case 143:
#line 528 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::TupleVariable(birch::LET, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_doc_loc((*yylocp))); }
#line 2108 "src/parser.cpp" /* glr.c:816  */
    break;

  case 144:
#line 532 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2114 "src/parser.cpp" /* glr.c:816  */
    break;

  case 145:
#line 532 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Function(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2120 "src/parser.cpp" /* glr.c:816  */
    break;

  case 146:
#line 536 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::ABSTRACT; }
#line 2126 "src/parser.cpp" /* glr.c:816  */
    break;

  case 147:
#line 537 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::FINAL; }
#line 2132 "src/parser.cpp" /* glr.c:816  */
    break;

  case 148:
#line 538 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::OVERRIDE; }
#line 2138 "src/parser.cpp" /* glr.c:816  */
    break;

  case 149:
#line 539 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::Annotation(birch::FINAL|birch::OVERRIDE); }
#line 2144 "src/parser.cpp" /* glr.c:816  */
    break;

  case 150:
#line 545 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2150 "src/parser.cpp" /* glr.c:816  */
    break;

  case 151:
#line 545 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::MemberFunction((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.valAnnotation), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2156 "src/parser.cpp" /* glr.c:816  */
    break;

  case 152:
#line 546 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2162 "src/parser.cpp" /* glr.c:816  */
    break;

  case 153:
#line 546 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::MemberFunction(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2168 "src/parser.cpp" /* glr.c:816  */
    break;

  case 154:
#line 550 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2174 "src/parser.cpp" /* glr.c:816  */
    break;

  case 155:
#line 550 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Program((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2180 "src/parser.cpp" /* glr.c:816  */
    break;

  case 162:
#line 563 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2186 "src/parser.cpp" /* glr.c:816  */
    break;

  case 163:
#line 563 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::BinaryOperator(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-8)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2192 "src/parser.cpp" /* glr.c:816  */
    break;

  case 165:
#line 571 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2198 "src/parser.cpp" /* glr.c:816  */
    break;

  case 166:
#line 571 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::UnaryOperator(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2204 "src/parser.cpp" /* glr.c:816  */
    break;

  case 167:
#line 575 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2210 "src/parser.cpp" /* glr.c:816  */
    break;

  case 168:
#line 575 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::AssignmentOperator(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2216 "src/parser.cpp" /* glr.c:816  */
    break;

  case 169:
#line 579 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2222 "src/parser.cpp" /* glr.c:816  */
    break;

  case 170:
#line 579 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::ConversionOperator(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2228 "src/parser.cpp" /* glr.c:816  */
    break;

  case 171:
#line 583 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2234 "src/parser.cpp" /* glr.c:816  */
    break;

  case 172:
#line 583 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::SliceOperator(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2240 "src/parser.cpp" /* glr.c:816  */
    break;

  case 173:
#line 587 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::ABSTRACT; }
#line 2246 "src/parser.cpp" /* glr.c:816  */
    break;

  case 174:
#line 588 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::FINAL; }
#line 2252 "src/parser.cpp" /* glr.c:816  */
    break;

  case 175:
#line 589 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::ACYCLIC; }
#line 2258 "src/parser.cpp" /* glr.c:816  */
    break;

  case 176:
#line 590 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::Annotation(birch::FINAL|birch::ACYCLIC); }
#line 2264 "src/parser.cpp" /* glr.c:816  */
    break;

  case 177:
#line 591 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::NONE; }
#line 2270 "src/parser.cpp" /* glr.c:816  */
    break;

  case 178:
#line 595 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2276 "src/parser.cpp" /* glr.c:816  */
    break;

  case 179:
#line 595 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Class((((yyGLRStackItem const *)yyvsp)[YYFILL (-9)].yystate.yysemantics.yysval.valAnnotation), (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valType), false, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2282 "src/parser.cpp" /* glr.c:816  */
    break;

  case 180:
#line 596 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2288 "src/parser.cpp" /* glr.c:816  */
    break;

  case 181:
#line 596 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Class((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.valAnnotation), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), empty_type((*yylocp)), false, empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2294 "src/parser.cpp" /* glr.c:816  */
    break;

  case 182:
#line 597 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2300 "src/parser.cpp" /* glr.c:816  */
    break;

  case 183:
#line 597 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Class((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.valAnnotation), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valExpression), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), true, empty_expr((*yylocp)), empty_stmt((*yylocp)), make_doc_loc((*yylocp))); }
#line 2306 "src/parser.cpp" /* glr.c:816  */
    break;

  case 184:
#line 601 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2312 "src/parser.cpp" /* glr.c:816  */
    break;

  case 185:
#line 601 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Struct(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valType), false, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2318 "src/parser.cpp" /* glr.c:816  */
    break;

  case 186:
#line 602 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2324 "src/parser.cpp" /* glr.c:816  */
    break;

  case 187:
#line 602 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Struct(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valExpression), empty_type((*yylocp)), false, empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_doc_loc((*yylocp))); }
#line 2330 "src/parser.cpp" /* glr.c:816  */
    break;

  case 188:
#line 603 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); }
#line 2336 "src/parser.cpp" /* glr.c:816  */
    break;

  case 189:
#line 603 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Struct(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.valExpression), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), true, empty_expr((*yylocp)), empty_stmt((*yylocp)), make_doc_loc((*yylocp))); }
#line 2342 "src/parser.cpp" /* glr.c:816  */
    break;

  case 190:
#line 607 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::Basic(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valName), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), false, make_doc_loc((*yylocp))); }
#line 2348 "src/parser.cpp" /* glr.c:816  */
    break;

  case 191:
#line 608 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::Basic(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valName), empty_expr((*yylocp)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), true, make_doc_loc((*yylocp))); }
#line 2354 "src/parser.cpp" /* glr.c:816  */
    break;

  case 192:
#line 609 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::Basic(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), empty_expr((*yylocp)), empty_type((*yylocp)), false, make_doc_loc((*yylocp))); }
#line 2360 "src/parser.cpp" /* glr.c:816  */
    break;

  case 193:
#line 613 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::Raw(new birch::Name("cpp"), pop_raw(), make_loc((*yylocp))); }
#line 2366 "src/parser.cpp" /* glr.c:816  */
    break;

  case 194:
#line 617 "src/parser.ypp" /* glr.c:816  */
    { push_raw(); ((*yyvalp).valStatement) = new birch::Raw(new birch::Name("hpp"), pop_raw(), make_loc((*yylocp))); }
#line 2372 "src/parser.cpp" /* glr.c:816  */
    break;

  case 195:
#line 621 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::ExpressionStatement((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 2378 "src/parser.cpp" /* glr.c:816  */
    break;

  case 196:
#line 625 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::If((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2384 "src/parser.cpp" /* glr.c:816  */
    break;

  case 197:
#line 626 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::If((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2390 "src/parser.cpp" /* glr.c:816  */
    break;

  case 198:
#line 627 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::If((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), empty_stmt((*yylocp)), make_loc((*yylocp))); }
#line 2396 "src/parser.cpp" /* glr.c:816  */
    break;

  case 199:
#line 631 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::LocalVariable((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valName), new birch::NamedType(new birch::Name("Integer")), make_loc((*yylocp))); }
#line 2402 "src/parser.cpp" /* glr.c:816  */
    break;

  case 200:
#line 635 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::For(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2408 "src/parser.cpp" /* glr.c:816  */
    break;

  case 201:
#line 639 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valAnnotation) = birch::DYNAMIC; }
#line 2414 "src/parser.cpp" /* glr.c:816  */
    break;

  case 202:
#line 645 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Parallel((((yyGLRStackItem const *)yyvsp)[YYFILL (-8)].yystate.yysemantics.yysval.valAnnotation), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2420 "src/parser.cpp" /* glr.c:816  */
    break;

  case 203:
#line 646 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Parallel(birch::NONE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2426 "src/parser.cpp" /* glr.c:816  */
    break;

  case 204:
#line 650 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::While((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2432 "src/parser.cpp" /* glr.c:816  */
    break;

  case 205:
#line 654 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::DoWhile((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 2438 "src/parser.cpp" /* glr.c:816  */
    break;

  case 206:
#line 658 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::With((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2444 "src/parser.cpp" /* glr.c:816  */
    break;

  case 207:
#line 662 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Block((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2450 "src/parser.cpp" /* glr.c:816  */
    break;

  case 208:
#line 666 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Assert((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 2456 "src/parser.cpp" /* glr.c:816  */
    break;

  case 209:
#line 670 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Return((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 2462 "src/parser.cpp" /* glr.c:816  */
    break;

  case 210:
#line 674 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Factor((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valExpression), make_loc((*yylocp))); }
#line 2468 "src/parser.cpp" /* glr.c:816  */
    break;

  case 226:
#line 696 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::StatementList((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2474 "src/parser.cpp" /* glr.c:816  */
    break;

  case 228:
#line 701 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = empty_stmt((*yylocp)); }
#line 2480 "src/parser.cpp" /* glr.c:816  */
    break;

  case 237:
#line 716 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::StatementList((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2486 "src/parser.cpp" /* glr.c:816  */
    break;

  case 239:
#line 721 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = empty_stmt((*yylocp)); }
#line 2492 "src/parser.cpp" /* glr.c:816  */
    break;

  case 244:
#line 732 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::StatementList((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2498 "src/parser.cpp" /* glr.c:816  */
    break;

  case 246:
#line 737 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = empty_stmt((*yylocp)); }
#line 2504 "src/parser.cpp" /* glr.c:816  */
    break;

  case 258:
#line 755 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::StatementList((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valStatement), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2510 "src/parser.cpp" /* glr.c:816  */
    break;

  case 260:
#line 760 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = empty_stmt((*yylocp)); }
#line 2516 "src/parser.cpp" /* glr.c:816  */
    break;

  case 261:
#line 764 "src/parser.ypp" /* glr.c:816  */
    { compiler->setRoot((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valStatement)); }
#line 2522 "src/parser.cpp" /* glr.c:816  */
    break;

  case 262:
#line 768 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valType); }
#line 2528 "src/parser.cpp" /* glr.c:816  */
    break;

  case 264:
#line 773 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = empty_type((*yylocp)); }
#line 2534 "src/parser.cpp" /* glr.c:816  */
    break;

  case 266:
#line 778 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = new birch::DeducedType(make_loc((*yylocp))); }
#line 2540 "src/parser.cpp" /* glr.c:816  */
    break;

  case 267:
#line 782 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Braces((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2546 "src/parser.cpp" /* glr.c:816  */
    break;

  case 269:
#line 787 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = empty_stmt((*yylocp)); }
#line 2552 "src/parser.cpp" /* glr.c:816  */
    break;

  case 270:
#line 791 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Braces((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2558 "src/parser.cpp" /* glr.c:816  */
    break;

  case 272:
#line 796 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = empty_stmt((*yylocp)); }
#line 2564 "src/parser.cpp" /* glr.c:816  */
    break;

  case 273:
#line 800 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = new birch::Braces((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valStatement), make_loc((*yylocp))); }
#line 2570 "src/parser.cpp" /* glr.c:816  */
    break;

  case 275:
#line 805 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valStatement) = empty_stmt((*yylocp)); }
#line 2576 "src/parser.cpp" /* glr.c:816  */
    break;

  case 277:
#line 818 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = new birch::NamedType((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))); }
#line 2582 "src/parser.cpp" /* glr.c:816  */
    break;

  case 278:
#line 819 "src/parser.ypp" /* glr.c:816  */
    { yywarn("using weak pointers is no longer necessary"); ((*yyvalp).valType) = new birch::NamedType((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valName), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))); }
#line 2588 "src/parser.cpp" /* glr.c:816  */
    break;

  case 280:
#line 824 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = new birch::TupleType((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))); }
#line 2594 "src/parser.cpp" /* glr.c:816  */
    break;

  case 282:
#line 829 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = new birch::OptionalType((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))); }
#line 2600 "src/parser.cpp" /* glr.c:816  */
    break;

  case 283:
#line 830 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = new birch::FutureType((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))); }
#line 2606 "src/parser.cpp" /* glr.c:816  */
    break;

  case 284:
#line 831 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = new birch::MemberType((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))); }
#line 2612 "src/parser.cpp" /* glr.c:816  */
    break;

  case 285:
#line 832 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = new birch::ArrayType((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.valInt), make_loc((*yylocp))); }
#line 2618 "src/parser.cpp" /* glr.c:816  */
    break;

  case 287:
#line 837 "src/parser.ypp" /* glr.c:816  */
    { ((*yyvalp).valType) = new birch::TypeList((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.valType), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.valType), make_loc((*yylocp))); }
#line 2624 "src/parser.cpp" /* glr.c:816  */
    break;


#line 2628 "src/parser.cpp" /* glr.c:816  */
      default: break;
    }

  return yyok;
# undef yyerrok
# undef YYABORT
# undef YYACCEPT
# undef YYERROR
# undef YYBACKUP
# undef yyclearin
# undef YYRECOVERING
}


static void
yyuserMerge (int yyn, YYSTYPE* yy0, YYSTYPE* yy1)
{
  YYUSE (yy0);
  YYUSE (yy1);

  switch (yyn)
    {

      default: break;
    }
}

                              /* Bison grammar-table manipulation.  */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}

/** Number of symbols composing the right hand side of rule #RULE.  */
static inline int
yyrhsLength (yyRuleNum yyrule)
{
  return yyr2[yyrule];
}

static void
yydestroyGLRState (char const *yymsg, yyGLRState *yys)
{
  if (yys->yyresolved)
    yydestruct (yymsg, yystos[yys->yylrState],
                &yys->yysemantics.yysval, &yys->yyloc);
  else
    {
#if YYDEBUG
      if (yydebug)
        {
          if (yys->yysemantics.yyfirstVal)
            YYFPRINTF (stderr, "%s unresolved", yymsg);
          else
            YYFPRINTF (stderr, "%s incomplete", yymsg);
          YY_SYMBOL_PRINT ("", yystos[yys->yylrState], YY_NULLPTR, &yys->yyloc);
        }
#endif

      if (yys->yysemantics.yyfirstVal)
        {
          yySemanticOption *yyoption = yys->yysemantics.yyfirstVal;
          yyGLRState *yyrh;
          int yyn;
          for (yyrh = yyoption->yystate, yyn = yyrhsLength (yyoption->yyrule);
               yyn > 0;
               yyrh = yyrh->yypred, yyn -= 1)
            yydestroyGLRState (yymsg, yyrh);
        }
    }
}

/** Left-hand-side symbol for rule #YYRULE.  */
static inline yySymbol
yylhsNonterm (yyRuleNum yyrule)
{
  return yyr1[yyrule];
}

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-356)))

/** True iff LR state YYSTATE has only a default reduction (regardless
 *  of token).  */
static inline yybool
yyisDefaultedState (yyStateNum yystate)
{
  return yypact_value_is_default (yypact[yystate]);
}

/** The default reduction for YYSTATE, assuming it has one.  */
static inline yyRuleNum
yydefaultAction (yyStateNum yystate)
{
  return yydefact[yystate];
}

#define yytable_value_is_error(Yytable_value) \
  0

/** Set *YYACTION to the action to take in YYSTATE on seeing YYTOKEN.
 *  Result R means
 *    R < 0:  Reduce on rule -R.
 *    R = 0:  Error.
 *    R > 0:  Shift to state R.
 *  Set *YYCONFLICTS to a pointer into yyconfl to a 0-terminated list
 *  of conflicting reductions.
 */
static inline void
yygetLRActions (yyStateNum yystate, int yytoken,
                int* yyaction, const short int** yyconflicts)
{
  int yyindex = yypact[yystate] + yytoken;
  if (yypact_value_is_default (yypact[yystate])
      || yyindex < 0 || YYLAST < yyindex || yycheck[yyindex] != yytoken)
    {
      *yyaction = -yydefact[yystate];
      *yyconflicts = yyconfl;
    }
  else if (! yytable_value_is_error (yytable[yyindex]))
    {
      *yyaction = yytable[yyindex];
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
  else
    {
      *yyaction = 0;
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
}

/** Compute post-reduction state.
 * \param yystate   the current state
 * \param yysym     the nonterminal to push on the stack
 */
static inline yyStateNum
yyLRgotoState (yyStateNum yystate, yySymbol yysym)
{
  int yyr = yypgoto[yysym - YYNTOKENS] + yystate;
  if (0 <= yyr && yyr <= YYLAST && yycheck[yyr] == yystate)
    return yytable[yyr];
  else
    return yydefgoto[yysym - YYNTOKENS];
}

static inline yybool
yyisShiftAction (int yyaction)
{
  return 0 < yyaction;
}

static inline yybool
yyisErrorAction (int yyaction)
{
  return yyaction == 0;
}

                                /* GLRStates */

/** Return a fresh GLRStackItem in YYSTACKP.  The item is an LR state
 *  if YYISSTATE, and otherwise a semantic option.  Callers should call
 *  YY_RESERVE_GLRSTACK afterwards to make sure there is sufficient
 *  headroom.  */

static inline yyGLRStackItem*
yynewGLRStackItem (yyGLRStack* yystackp, yybool yyisState)
{
  yyGLRStackItem* yynewItem = yystackp->yynextFree;
  yystackp->yyspaceLeft -= 1;
  yystackp->yynextFree += 1;
  yynewItem->yystate.yyisState = yyisState;
  return yynewItem;
}

/** Add a new semantic action that will execute the action for rule
 *  YYRULE on the semantic values in YYRHS to the list of
 *  alternative actions for YYSTATE.  Assumes that YYRHS comes from
 *  stack #YYK of *YYSTACKP. */
static void
yyaddDeferredAction (yyGLRStack* yystackp, size_t yyk, yyGLRState* yystate,
                     yyGLRState* yyrhs, yyRuleNum yyrule)
{
  yySemanticOption* yynewOption =
    &yynewGLRStackItem (yystackp, yyfalse)->yyoption;
  YYASSERT (!yynewOption->yyisState);
  yynewOption->yystate = yyrhs;
  yynewOption->yyrule = yyrule;
  if (yystackp->yytops.yylookaheadNeeds[yyk])
    {
      yynewOption->yyrawchar = yychar;
      yynewOption->yyval = yylval;
      yynewOption->yyloc = yylloc;
    }
  else
    yynewOption->yyrawchar = YYEMPTY;
  yynewOption->yynext = yystate->yysemantics.yyfirstVal;
  yystate->yysemantics.yyfirstVal = yynewOption;

  YY_RESERVE_GLRSTACK (yystackp);
}

                                /* GLRStacks */

/** Initialize YYSET to a singleton set containing an empty stack.  */
static yybool
yyinitStateSet (yyGLRStateSet* yyset)
{
  yyset->yysize = 1;
  yyset->yycapacity = 16;
  yyset->yystates = (yyGLRState**) YYMALLOC (16 * sizeof yyset->yystates[0]);
  if (! yyset->yystates)
    return yyfalse;
  yyset->yystates[0] = YY_NULLPTR;
  yyset->yylookaheadNeeds =
    (yybool*) YYMALLOC (16 * sizeof yyset->yylookaheadNeeds[0]);
  if (! yyset->yylookaheadNeeds)
    {
      YYFREE (yyset->yystates);
      return yyfalse;
    }
  return yytrue;
}

static void yyfreeStateSet (yyGLRStateSet* yyset)
{
  YYFREE (yyset->yystates);
  YYFREE (yyset->yylookaheadNeeds);
}

/** Initialize *YYSTACKP to a single empty stack, with total maximum
 *  capacity for all stacks of YYSIZE.  */
static yybool
yyinitGLRStack (yyGLRStack* yystackp, size_t yysize)
{
  yystackp->yyerrState = 0;
  yynerrs = 0;
  yystackp->yyspaceLeft = yysize;
  yystackp->yyitems =
    (yyGLRStackItem*) YYMALLOC (yysize * sizeof yystackp->yynextFree[0]);
  if (!yystackp->yyitems)
    return yyfalse;
  yystackp->yynextFree = yystackp->yyitems;
  yystackp->yysplitPoint = YY_NULLPTR;
  yystackp->yylastDeleted = YY_NULLPTR;
  return yyinitStateSet (&yystackp->yytops);
}


#if YYSTACKEXPANDABLE
# define YYRELOC(YYFROMITEMS,YYTOITEMS,YYX,YYTYPE) \
  &((YYTOITEMS) - ((YYFROMITEMS) - (yyGLRStackItem*) (YYX)))->YYTYPE

/** If *YYSTACKP is expandable, extend it.  WARNING: Pointers into the
    stack from outside should be considered invalid after this call.
    We always expand when there are 1 or fewer items left AFTER an
    allocation, so that we can avoid having external pointers exist
    across an allocation.  */
static void
yyexpandGLRStack (yyGLRStack* yystackp)
{
  yyGLRStackItem* yynewItems;
  yyGLRStackItem* yyp0, *yyp1;
  size_t yynewSize;
  size_t yyn;
  size_t yysize = yystackp->yynextFree - yystackp->yyitems;
  if (YYMAXDEPTH - YYHEADROOM < yysize)
    yyMemoryExhausted (yystackp);
  yynewSize = 2*yysize;
  if (YYMAXDEPTH < yynewSize)
    yynewSize = YYMAXDEPTH;
  yynewItems = (yyGLRStackItem*) YYMALLOC (yynewSize * sizeof yynewItems[0]);
  if (! yynewItems)
    yyMemoryExhausted (yystackp);
  for (yyp0 = yystackp->yyitems, yyp1 = yynewItems, yyn = yysize;
       0 < yyn;
       yyn -= 1, yyp0 += 1, yyp1 += 1)
    {
      *yyp1 = *yyp0;
      if (*(yybool *) yyp0)
        {
          yyGLRState* yys0 = &yyp0->yystate;
          yyGLRState* yys1 = &yyp1->yystate;
          if (yys0->yypred != YY_NULLPTR)
            yys1->yypred =
              YYRELOC (yyp0, yyp1, yys0->yypred, yystate);
          if (! yys0->yyresolved && yys0->yysemantics.yyfirstVal != YY_NULLPTR)
            yys1->yysemantics.yyfirstVal =
              YYRELOC (yyp0, yyp1, yys0->yysemantics.yyfirstVal, yyoption);
        }
      else
        {
          yySemanticOption* yyv0 = &yyp0->yyoption;
          yySemanticOption* yyv1 = &yyp1->yyoption;
          if (yyv0->yystate != YY_NULLPTR)
            yyv1->yystate = YYRELOC (yyp0, yyp1, yyv0->yystate, yystate);
          if (yyv0->yynext != YY_NULLPTR)
            yyv1->yynext = YYRELOC (yyp0, yyp1, yyv0->yynext, yyoption);
        }
    }
  if (yystackp->yysplitPoint != YY_NULLPTR)
    yystackp->yysplitPoint = YYRELOC (yystackp->yyitems, yynewItems,
                                      yystackp->yysplitPoint, yystate);

  for (yyn = 0; yyn < yystackp->yytops.yysize; yyn += 1)
    if (yystackp->yytops.yystates[yyn] != YY_NULLPTR)
      yystackp->yytops.yystates[yyn] =
        YYRELOC (yystackp->yyitems, yynewItems,
                 yystackp->yytops.yystates[yyn], yystate);
  YYFREE (yystackp->yyitems);
  yystackp->yyitems = yynewItems;
  yystackp->yynextFree = yynewItems + yysize;
  yystackp->yyspaceLeft = yynewSize - yysize;
}
#endif

static void
yyfreeGLRStack (yyGLRStack* yystackp)
{
  YYFREE (yystackp->yyitems);
  yyfreeStateSet (&yystackp->yytops);
}

/** Assuming that YYS is a GLRState somewhere on *YYSTACKP, update the
 *  splitpoint of *YYSTACKP, if needed, so that it is at least as deep as
 *  YYS.  */
static inline void
yyupdateSplit (yyGLRStack* yystackp, yyGLRState* yys)
{
  if (yystackp->yysplitPoint != YY_NULLPTR && yystackp->yysplitPoint > yys)
    yystackp->yysplitPoint = yys;
}

/** Invalidate stack #YYK in *YYSTACKP.  */
static inline void
yymarkStackDeleted (yyGLRStack* yystackp, size_t yyk)
{
  if (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
    yystackp->yylastDeleted = yystackp->yytops.yystates[yyk];
  yystackp->yytops.yystates[yyk] = YY_NULLPTR;
}

/** Undelete the last stack in *YYSTACKP that was marked as deleted.  Can
    only be done once after a deletion, and only when all other stacks have
    been deleted.  */
static void
yyundeleteLastStack (yyGLRStack* yystackp)
{
  if (yystackp->yylastDeleted == YY_NULLPTR || yystackp->yytops.yysize != 0)
    return;
  yystackp->yytops.yystates[0] = yystackp->yylastDeleted;
  yystackp->yytops.yysize = 1;
  YYDPRINTF ((stderr, "Restoring last deleted stack as stack #0.\n"));
  yystackp->yylastDeleted = YY_NULLPTR;
}

static inline void
yyremoveDeletes (yyGLRStack* yystackp)
{
  size_t yyi, yyj;
  yyi = yyj = 0;
  while (yyj < yystackp->yytops.yysize)
    {
      if (yystackp->yytops.yystates[yyi] == YY_NULLPTR)
        {
          if (yyi == yyj)
            {
              YYDPRINTF ((stderr, "Removing dead stacks.\n"));
            }
          yystackp->yytops.yysize -= 1;
        }
      else
        {
          yystackp->yytops.yystates[yyj] = yystackp->yytops.yystates[yyi];
          /* In the current implementation, it's unnecessary to copy
             yystackp->yytops.yylookaheadNeeds[yyi] since, after
             yyremoveDeletes returns, the parser immediately either enters
             deterministic operation or shifts a token.  However, it doesn't
             hurt, and the code might evolve to need it.  */
          yystackp->yytops.yylookaheadNeeds[yyj] =
            yystackp->yytops.yylookaheadNeeds[yyi];
          if (yyj != yyi)
            {
              YYDPRINTF ((stderr, "Rename stack %lu -> %lu.\n",
                          (unsigned long int) yyi, (unsigned long int) yyj));
            }
          yyj += 1;
        }
      yyi += 1;
    }
}

/** Shift to a new state on stack #YYK of *YYSTACKP, corresponding to LR
 * state YYLRSTATE, at input position YYPOSN, with (resolved) semantic
 * value *YYVALP and source location *YYLOCP.  */
static inline void
yyglrShift (yyGLRStack* yystackp, size_t yyk, yyStateNum yylrState,
            size_t yyposn,
            YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  yyGLRState* yynewState = &yynewGLRStackItem (yystackp, yytrue)->yystate;

  yynewState->yylrState = yylrState;
  yynewState->yyposn = yyposn;
  yynewState->yyresolved = yytrue;
  yynewState->yypred = yystackp->yytops.yystates[yyk];
  yynewState->yysemantics.yysval = *yyvalp;
  yynewState->yyloc = *yylocp;
  yystackp->yytops.yystates[yyk] = yynewState;

  YY_RESERVE_GLRSTACK (yystackp);
}

/** Shift stack #YYK of *YYSTACKP, to a new state corresponding to LR
 *  state YYLRSTATE, at input position YYPOSN, with the (unresolved)
 *  semantic value of YYRHS under the action for YYRULE.  */
static inline void
yyglrShiftDefer (yyGLRStack* yystackp, size_t yyk, yyStateNum yylrState,
                 size_t yyposn, yyGLRState* yyrhs, yyRuleNum yyrule)
{
  yyGLRState* yynewState = &yynewGLRStackItem (yystackp, yytrue)->yystate;
  YYASSERT (yynewState->yyisState);

  yynewState->yylrState = yylrState;
  yynewState->yyposn = yyposn;
  yynewState->yyresolved = yyfalse;
  yynewState->yypred = yystackp->yytops.yystates[yyk];
  yynewState->yysemantics.yyfirstVal = YY_NULLPTR;
  yystackp->yytops.yystates[yyk] = yynewState;

  /* Invokes YY_RESERVE_GLRSTACK.  */
  yyaddDeferredAction (yystackp, yyk, yynewState, yyrhs, yyrule);
}

#if !YYDEBUG
# define YY_REDUCE_PRINT(Args)
#else
# define YY_REDUCE_PRINT(Args)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print Args;               \
} while (0)

/*----------------------------------------------------------------------.
| Report that stack #YYK of *YYSTACKP is going to be reduced by YYRULE. |
`----------------------------------------------------------------------*/

static inline void
yy_reduce_print (int yynormal, yyGLRStackItem* yyvsp, size_t yyk,
                 yyRuleNum yyrule)
{
  int yynrhs = yyrhsLength (yyrule);
  int yylow = 1;
  int yyi;
  YYFPRINTF (stderr, "Reducing stack %lu by rule %d (line %lu):\n",
             (unsigned long int) yyk, yyrule - 1,
             (unsigned long int) yyrline[yyrule]);
  if (! yynormal)
    yyfillin (yyvsp, 1, -yynrhs);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyvsp[yyi - yynrhs + 1].yystate.yylrState],
                       &yyvsp[yyi - yynrhs + 1].yystate.yysemantics.yysval
                       , &(((yyGLRStackItem const *)yyvsp)[YYFILL ((yyi + 1) - (yynrhs))].yystate.yyloc)                       );
      if (!yyvsp[yyi - yynrhs + 1].yystate.yyresolved)
        YYFPRINTF (stderr, " (unresolved)");
      YYFPRINTF (stderr, "\n");
    }
}
#endif

/** Pop the symbols consumed by reduction #YYRULE from the top of stack
 *  #YYK of *YYSTACKP, and perform the appropriate semantic action on their
 *  semantic values.  Assumes that all ambiguities in semantic values
 *  have been previously resolved.  Set *YYVALP to the resulting value,
 *  and *YYLOCP to the computed location (if any).  Return value is as
 *  for userAction.  */
static inline YYRESULTTAG
yydoAction (yyGLRStack* yystackp, size_t yyk, yyRuleNum yyrule,
            YYSTYPE* yyvalp, YYLTYPE *yylocp)
{
  int yynrhs = yyrhsLength (yyrule);

  if (yystackp->yysplitPoint == YY_NULLPTR)
    {
      /* Standard special case: single stack.  */
      yyGLRStackItem* yyrhs = (yyGLRStackItem*) yystackp->yytops.yystates[yyk];
      YYASSERT (yyk == 0);
      yystackp->yynextFree -= yynrhs;
      yystackp->yyspaceLeft += yynrhs;
      yystackp->yytops.yystates[0] = & yystackp->yynextFree[-1].yystate;
      YY_REDUCE_PRINT ((1, yyrhs, yyk, yyrule));
      return yyuserAction (yyrule, yynrhs, yyrhs, yystackp,
                           yyvalp, yylocp);
    }
  else
    {
      int yyi;
      yyGLRState* yys;
      yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
      yys = yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred
        = yystackp->yytops.yystates[yyk];
      if (yynrhs == 0)
        /* Set default location.  */
        yyrhsVals[YYMAXRHS + YYMAXLEFT - 1].yystate.yyloc = yys->yyloc;
      for (yyi = 0; yyi < yynrhs; yyi += 1)
        {
          yys = yys->yypred;
          YYASSERT (yys);
        }
      yyupdateSplit (yystackp, yys);
      yystackp->yytops.yystates[yyk] = yys;
      YY_REDUCE_PRINT ((0, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1, yyk, yyrule));
      return yyuserAction (yyrule, yynrhs, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                           yystackp, yyvalp, yylocp);
    }
}

/** Pop items off stack #YYK of *YYSTACKP according to grammar rule YYRULE,
 *  and push back on the resulting nonterminal symbol.  Perform the
 *  semantic action associated with YYRULE and store its value with the
 *  newly pushed state, if YYFORCEEVAL or if *YYSTACKP is currently
 *  unambiguous.  Otherwise, store the deferred semantic action with
 *  the new state.  If the new state would have an identical input
 *  position, LR state, and predecessor to an existing state on the stack,
 *  it is identified with that existing state, eliminating stack #YYK from
 *  *YYSTACKP.  In this case, the semantic value is
 *  added to the options for the existing state's semantic value.
 */
static inline YYRESULTTAG
yyglrReduce (yyGLRStack* yystackp, size_t yyk, yyRuleNum yyrule,
             yybool yyforceEval)
{
  size_t yyposn = yystackp->yytops.yystates[yyk]->yyposn;

  if (yyforceEval || yystackp->yysplitPoint == YY_NULLPTR)
    {
      YYSTYPE yysval;
      YYLTYPE yyloc;

      YYRESULTTAG yyflag = yydoAction (yystackp, yyk, yyrule, &yysval, &yyloc);
      if (yyflag == yyerr && yystackp->yysplitPoint != YY_NULLPTR)
        {
          YYDPRINTF ((stderr, "Parse on stack %lu rejected by rule #%d.\n",
                     (unsigned long int) yyk, yyrule - 1));
        }
      if (yyflag != yyok)
        return yyflag;
      YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyrule], &yysval, &yyloc);
      yyglrShift (yystackp, yyk,
                  yyLRgotoState (yystackp->yytops.yystates[yyk]->yylrState,
                                 yylhsNonterm (yyrule)),
                  yyposn, &yysval, &yyloc);
    }
  else
    {
      size_t yyi;
      int yyn;
      yyGLRState* yys, *yys0 = yystackp->yytops.yystates[yyk];
      yyStateNum yynewLRState;

      for (yys = yystackp->yytops.yystates[yyk], yyn = yyrhsLength (yyrule);
           0 < yyn; yyn -= 1)
        {
          yys = yys->yypred;
          YYASSERT (yys);
        }
      yyupdateSplit (yystackp, yys);
      yynewLRState = yyLRgotoState (yys->yylrState, yylhsNonterm (yyrule));
      YYDPRINTF ((stderr,
                  "Reduced stack %lu by rule #%d; action deferred.  "
                  "Now in state %d.\n",
                  (unsigned long int) yyk, yyrule - 1, yynewLRState));
      for (yyi = 0; yyi < yystackp->yytops.yysize; yyi += 1)
        if (yyi != yyk && yystackp->yytops.yystates[yyi] != YY_NULLPTR)
          {
            yyGLRState *yysplit = yystackp->yysplitPoint;
            yyGLRState *yyp = yystackp->yytops.yystates[yyi];
            while (yyp != yys && yyp != yysplit && yyp->yyposn >= yyposn)
              {
                if (yyp->yylrState == yynewLRState && yyp->yypred == yys)
                  {
                    yyaddDeferredAction (yystackp, yyk, yyp, yys0, yyrule);
                    yymarkStackDeleted (yystackp, yyk);
                    YYDPRINTF ((stderr, "Merging stack %lu into stack %lu.\n",
                                (unsigned long int) yyk,
                                (unsigned long int) yyi));
                    return yyok;
                  }
                yyp = yyp->yypred;
              }
          }
      yystackp->yytops.yystates[yyk] = yys;
      yyglrShiftDefer (yystackp, yyk, yynewLRState, yyposn, yys0, yyrule);
    }
  return yyok;
}

static size_t
yysplitStack (yyGLRStack* yystackp, size_t yyk)
{
  if (yystackp->yysplitPoint == YY_NULLPTR)
    {
      YYASSERT (yyk == 0);
      yystackp->yysplitPoint = yystackp->yytops.yystates[yyk];
    }
  if (yystackp->yytops.yysize >= yystackp->yytops.yycapacity)
    {
      yyGLRState** yynewStates;
      yybool* yynewLookaheadNeeds;

      yynewStates = YY_NULLPTR;

      if (yystackp->yytops.yycapacity
          > (YYSIZEMAX / (2 * sizeof yynewStates[0])))
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yycapacity *= 2;

      yynewStates =
        (yyGLRState**) YYREALLOC (yystackp->yytops.yystates,
                                  (yystackp->yytops.yycapacity
                                   * sizeof yynewStates[0]));
      if (yynewStates == YY_NULLPTR)
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yystates = yynewStates;

      yynewLookaheadNeeds =
        (yybool*) YYREALLOC (yystackp->yytops.yylookaheadNeeds,
                             (yystackp->yytops.yycapacity
                              * sizeof yynewLookaheadNeeds[0]));
      if (yynewLookaheadNeeds == YY_NULLPTR)
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yylookaheadNeeds = yynewLookaheadNeeds;
    }
  yystackp->yytops.yystates[yystackp->yytops.yysize]
    = yystackp->yytops.yystates[yyk];
  yystackp->yytops.yylookaheadNeeds[yystackp->yytops.yysize]
    = yystackp->yytops.yylookaheadNeeds[yyk];
  yystackp->yytops.yysize += 1;
  return yystackp->yytops.yysize-1;
}

/** True iff YYY0 and YYY1 represent identical options at the top level.
 *  That is, they represent the same rule applied to RHS symbols
 *  that produce the same terminal symbols.  */
static yybool
yyidenticalOptions (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  if (yyy0->yyrule == yyy1->yyrule)
    {
      yyGLRState *yys0, *yys1;
      int yyn;
      for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
           yyn = yyrhsLength (yyy0->yyrule);
           yyn > 0;
           yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
        if (yys0->yyposn != yys1->yyposn)
          return yyfalse;
      return yytrue;
    }
  else
    return yyfalse;
}

/** Assuming identicalOptions (YYY0,YYY1), destructively merge the
 *  alternative semantic values for the RHS-symbols of YYY1 and YYY0.  */
static void
yymergeOptionSets (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  yyGLRState *yys0, *yys1;
  int yyn;
  for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
       yyn = yyrhsLength (yyy0->yyrule);
       yyn > 0;
       yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
    {
      if (yys0 == yys1)
        break;
      else if (yys0->yyresolved)
        {
          yys1->yyresolved = yytrue;
          yys1->yysemantics.yysval = yys0->yysemantics.yysval;
        }
      else if (yys1->yyresolved)
        {
          yys0->yyresolved = yytrue;
          yys0->yysemantics.yysval = yys1->yysemantics.yysval;
        }
      else
        {
          yySemanticOption** yyz0p = &yys0->yysemantics.yyfirstVal;
          yySemanticOption* yyz1 = yys1->yysemantics.yyfirstVal;
          while (yytrue)
            {
              if (yyz1 == *yyz0p || yyz1 == YY_NULLPTR)
                break;
              else if (*yyz0p == YY_NULLPTR)
                {
                  *yyz0p = yyz1;
                  break;
                }
              else if (*yyz0p < yyz1)
                {
                  yySemanticOption* yyz = *yyz0p;
                  *yyz0p = yyz1;
                  yyz1 = yyz1->yynext;
                  (*yyz0p)->yynext = yyz;
                }
              yyz0p = &(*yyz0p)->yynext;
            }
          yys1->yysemantics.yyfirstVal = yys0->yysemantics.yyfirstVal;
        }
    }
}

/** Y0 and Y1 represent two possible actions to take in a given
 *  parsing state; return 0 if no combination is possible,
 *  1 if user-mergeable, 2 if Y0 is preferred, 3 if Y1 is preferred.  */
static int
yypreference (yySemanticOption* y0, yySemanticOption* y1)
{
  yyRuleNum r0 = y0->yyrule, r1 = y1->yyrule;
  int p0 = yydprec[r0], p1 = yydprec[r1];

  if (p0 == p1)
    {
      if (yymerger[r0] == 0 || yymerger[r0] != yymerger[r1])
        return 0;
      else
        return 1;
    }
  if (p0 == 0 || p1 == 0)
    return 0;
  if (p0 < p1)
    return 3;
  if (p1 < p0)
    return 2;
  return 0;
}

static YYRESULTTAG yyresolveValue (yyGLRState* yys,
                                   yyGLRStack* yystackp);


/** Resolve the previous YYN states starting at and including state YYS
 *  on *YYSTACKP. If result != yyok, some states may have been left
 *  unresolved possibly with empty semantic option chains.  Regardless
 *  of whether result = yyok, each state has been left with consistent
 *  data so that yydestroyGLRState can be invoked if necessary.  */
static YYRESULTTAG
yyresolveStates (yyGLRState* yys, int yyn,
                 yyGLRStack* yystackp)
{
  if (0 < yyn)
    {
      YYASSERT (yys->yypred);
      YYCHK (yyresolveStates (yys->yypred, yyn-1, yystackp));
      if (! yys->yyresolved)
        YYCHK (yyresolveValue (yys, yystackp));
    }
  return yyok;
}

/** Resolve the states for the RHS of YYOPT on *YYSTACKP, perform its
 *  user action, and return the semantic value and location in *YYVALP
 *  and *YYLOCP.  Regardless of whether result = yyok, all RHS states
 *  have been destroyed (assuming the user action destroys all RHS
 *  semantic values if invoked).  */
static YYRESULTTAG
yyresolveAction (yySemanticOption* yyopt, yyGLRStack* yystackp,
                 YYSTYPE* yyvalp, YYLTYPE *yylocp)
{
  yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
  int yynrhs = yyrhsLength (yyopt->yyrule);
  YYRESULTTAG yyflag =
    yyresolveStates (yyopt->yystate, yynrhs, yystackp);
  if (yyflag != yyok)
    {
      yyGLRState *yys;
      for (yys = yyopt->yystate; yynrhs > 0; yys = yys->yypred, yynrhs -= 1)
        yydestroyGLRState ("Cleanup: popping", yys);
      return yyflag;
    }

  yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred = yyopt->yystate;
  if (yynrhs == 0)
    /* Set default location.  */
    yyrhsVals[YYMAXRHS + YYMAXLEFT - 1].yystate.yyloc = yyopt->yystate->yyloc;
  {
    int yychar_current = yychar;
    YYSTYPE yylval_current = yylval;
    YYLTYPE yylloc_current = yylloc;
    yychar = yyopt->yyrawchar;
    yylval = yyopt->yyval;
    yylloc = yyopt->yyloc;
    yyflag = yyuserAction (yyopt->yyrule, yynrhs,
                           yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                           yystackp, yyvalp, yylocp);
    yychar = yychar_current;
    yylval = yylval_current;
    yylloc = yylloc_current;
  }
  return yyflag;
}

#if YYDEBUG
static void
yyreportTree (yySemanticOption* yyx, int yyindent)
{
  int yynrhs = yyrhsLength (yyx->yyrule);
  int yyi;
  yyGLRState* yys;
  yyGLRState* yystates[1 + YYMAXRHS];
  yyGLRState yyleftmost_state;

  for (yyi = yynrhs, yys = yyx->yystate; 0 < yyi; yyi -= 1, yys = yys->yypred)
    yystates[yyi] = yys;
  if (yys == YY_NULLPTR)
    {
      yyleftmost_state.yyposn = 0;
      yystates[0] = &yyleftmost_state;
    }
  else
    yystates[0] = yys;

  if (yyx->yystate->yyposn < yys->yyposn + 1)
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, empty>\n",
               yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
               yyx->yyrule - 1);
  else
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, tokens %lu .. %lu>\n",
               yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
               yyx->yyrule - 1, (unsigned long int) (yys->yyposn + 1),
               (unsigned long int) yyx->yystate->yyposn);
  for (yyi = 1; yyi <= yynrhs; yyi += 1)
    {
      if (yystates[yyi]->yyresolved)
        {
          if (yystates[yyi-1]->yyposn+1 > yystates[yyi]->yyposn)
            YYFPRINTF (stderr, "%*s%s <empty>\n", yyindent+2, "",
                       yytokenName (yystos[yystates[yyi]->yylrState]));
          else
            YYFPRINTF (stderr, "%*s%s <tokens %lu .. %lu>\n", yyindent+2, "",
                       yytokenName (yystos[yystates[yyi]->yylrState]),
                       (unsigned long int) (yystates[yyi-1]->yyposn + 1),
                       (unsigned long int) yystates[yyi]->yyposn);
        }
      else
        yyreportTree (yystates[yyi]->yysemantics.yyfirstVal, yyindent+2);
    }
}
#endif

static YYRESULTTAG
yyreportAmbiguity (yySemanticOption* yyx0,
                   yySemanticOption* yyx1)
{
  YYUSE (yyx0);
  YYUSE (yyx1);

#if YYDEBUG
  YYFPRINTF (stderr, "Ambiguity detected.\n");
  YYFPRINTF (stderr, "Option 1,\n");
  yyreportTree (yyx0, 2);
  YYFPRINTF (stderr, "\nOption 2,\n");
  yyreportTree (yyx1, 2);
  YYFPRINTF (stderr, "\n");
#endif

  yyerror (YY_("syntax is ambiguous"));
  return yyabort;
}

/** Resolve the locations for each of the YYN1 states in *YYSTACKP,
 *  ending at YYS1.  Has no effect on previously resolved states.
 *  The first semantic option of a state is always chosen.  */
static void
yyresolveLocations (yyGLRState* yys1, int yyn1,
                    yyGLRStack *yystackp)
{
  if (0 < yyn1)
    {
      yyresolveLocations (yys1->yypred, yyn1 - 1, yystackp);
      if (!yys1->yyresolved)
        {
          yyGLRStackItem yyrhsloc[1 + YYMAXRHS];
          int yynrhs;
          yySemanticOption *yyoption = yys1->yysemantics.yyfirstVal;
          YYASSERT (yyoption != YY_NULLPTR);
          yynrhs = yyrhsLength (yyoption->yyrule);
          if (yynrhs > 0)
            {
              yyGLRState *yys;
              int yyn;
              yyresolveLocations (yyoption->yystate, yynrhs,
                                  yystackp);
              for (yys = yyoption->yystate, yyn = yynrhs;
                   yyn > 0;
                   yys = yys->yypred, yyn -= 1)
                yyrhsloc[yyn].yystate.yyloc = yys->yyloc;
            }
          else
            {
              /* Both yyresolveAction and yyresolveLocations traverse the GSS
                 in reverse rightmost order.  It is only necessary to invoke
                 yyresolveLocations on a subforest for which yyresolveAction
                 would have been invoked next had an ambiguity not been
                 detected.  Thus the location of the previous state (but not
                 necessarily the previous state itself) is guaranteed to be
                 resolved already.  */
              yyGLRState *yyprevious = yyoption->yystate;
              yyrhsloc[0].yystate.yyloc = yyprevious->yyloc;
            }
          {
            int yychar_current = yychar;
            YYSTYPE yylval_current = yylval;
            YYLTYPE yylloc_current = yylloc;
            yychar = yyoption->yyrawchar;
            yylval = yyoption->yyval;
            yylloc = yyoption->yyloc;
            YYLLOC_DEFAULT ((yys1->yyloc), yyrhsloc, yynrhs);
            yychar = yychar_current;
            yylval = yylval_current;
            yylloc = yylloc_current;
          }
        }
    }
}

/** Resolve the ambiguity represented in state YYS in *YYSTACKP,
 *  perform the indicated actions, and set the semantic value of YYS.
 *  If result != yyok, the chain of semantic options in YYS has been
 *  cleared instead or it has been left unmodified except that
 *  redundant options may have been removed.  Regardless of whether
 *  result = yyok, YYS has been left with consistent data so that
 *  yydestroyGLRState can be invoked if necessary.  */
static YYRESULTTAG
yyresolveValue (yyGLRState* yys, yyGLRStack* yystackp)
{
  yySemanticOption* yyoptionList = yys->yysemantics.yyfirstVal;
  yySemanticOption* yybest = yyoptionList;
  yySemanticOption** yypp;
  yybool yymerge = yyfalse;
  YYSTYPE yysval;
  YYRESULTTAG yyflag;
  YYLTYPE *yylocp = &yys->yyloc;

  for (yypp = &yyoptionList->yynext; *yypp != YY_NULLPTR; )
    {
      yySemanticOption* yyp = *yypp;

      if (yyidenticalOptions (yybest, yyp))
        {
          yymergeOptionSets (yybest, yyp);
          *yypp = yyp->yynext;
        }
      else
        {
          switch (yypreference (yybest, yyp))
            {
            case 0:
              yyresolveLocations (yys, 1, yystackp);
              return yyreportAmbiguity (yybest, yyp);
              break;
            case 1:
              yymerge = yytrue;
              break;
            case 2:
              break;
            case 3:
              yybest = yyp;
              yymerge = yyfalse;
              break;
            default:
              /* This cannot happen so it is not worth a YYASSERT (yyfalse),
                 but some compilers complain if the default case is
                 omitted.  */
              break;
            }
          yypp = &yyp->yynext;
        }
    }

  if (yymerge)
    {
      yySemanticOption* yyp;
      int yyprec = yydprec[yybest->yyrule];
      yyflag = yyresolveAction (yybest, yystackp, &yysval, yylocp);
      if (yyflag == yyok)
        for (yyp = yybest->yynext; yyp != YY_NULLPTR; yyp = yyp->yynext)
          {
            if (yyprec == yydprec[yyp->yyrule])
              {
                YYSTYPE yysval_other;
                YYLTYPE yydummy;
                yyflag = yyresolveAction (yyp, yystackp, &yysval_other, &yydummy);
                if (yyflag != yyok)
                  {
                    yydestruct ("Cleanup: discarding incompletely merged value for",
                                yystos[yys->yylrState],
                                &yysval, yylocp);
                    break;
                  }
                yyuserMerge (yymerger[yyp->yyrule], &yysval, &yysval_other);
              }
          }
    }
  else
    yyflag = yyresolveAction (yybest, yystackp, &yysval, yylocp);

  if (yyflag == yyok)
    {
      yys->yyresolved = yytrue;
      yys->yysemantics.yysval = yysval;
    }
  else
    yys->yysemantics.yyfirstVal = YY_NULLPTR;
  return yyflag;
}

static YYRESULTTAG
yyresolveStack (yyGLRStack* yystackp)
{
  if (yystackp->yysplitPoint != YY_NULLPTR)
    {
      yyGLRState* yys;
      int yyn;

      for (yyn = 0, yys = yystackp->yytops.yystates[0];
           yys != yystackp->yysplitPoint;
           yys = yys->yypred, yyn += 1)
        continue;
      YYCHK (yyresolveStates (yystackp->yytops.yystates[0], yyn, yystackp
                             ));
    }
  return yyok;
}

static void
yycompressStack (yyGLRStack* yystackp)
{
  yyGLRState* yyp, *yyq, *yyr;

  if (yystackp->yytops.yysize != 1 || yystackp->yysplitPoint == YY_NULLPTR)
    return;

  for (yyp = yystackp->yytops.yystates[0], yyq = yyp->yypred, yyr = YY_NULLPTR;
       yyp != yystackp->yysplitPoint;
       yyr = yyp, yyp = yyq, yyq = yyp->yypred)
    yyp->yypred = yyr;

  yystackp->yyspaceLeft += yystackp->yynextFree - yystackp->yyitems;
  yystackp->yynextFree = ((yyGLRStackItem*) yystackp->yysplitPoint) + 1;
  yystackp->yyspaceLeft -= yystackp->yynextFree - yystackp->yyitems;
  yystackp->yysplitPoint = YY_NULLPTR;
  yystackp->yylastDeleted = YY_NULLPTR;

  while (yyr != YY_NULLPTR)
    {
      yystackp->yynextFree->yystate = *yyr;
      yyr = yyr->yypred;
      yystackp->yynextFree->yystate.yypred = &yystackp->yynextFree[-1].yystate;
      yystackp->yytops.yystates[0] = &yystackp->yynextFree->yystate;
      yystackp->yynextFree += 1;
      yystackp->yyspaceLeft -= 1;
    }
}

static YYRESULTTAG
yyprocessOneStack (yyGLRStack* yystackp, size_t yyk,
                   size_t yyposn)
{
  while (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
    {
      yyStateNum yystate = yystackp->yytops.yystates[yyk]->yylrState;
      YYDPRINTF ((stderr, "Stack %lu Entering state %d\n",
                  (unsigned long int) yyk, yystate));

      YYASSERT (yystate != YYFINAL);

      if (yyisDefaultedState (yystate))
        {
          YYRESULTTAG yyflag;
          yyRuleNum yyrule = yydefaultAction (yystate);
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, "Stack %lu dies.\n",
                          (unsigned long int) yyk));
              yymarkStackDeleted (yystackp, yyk);
              return yyok;
            }
          yyflag = yyglrReduce (yystackp, yyk, yyrule, yyimmediate[yyrule]);
          if (yyflag == yyerr)
            {
              YYDPRINTF ((stderr,
                          "Stack %lu dies "
                          "(predicate failure or explicit user error).\n",
                          (unsigned long int) yyk));
              yymarkStackDeleted (yystackp, yyk);
              return yyok;
            }
          if (yyflag != yyok)
            return yyflag;
        }
      else
        {
          yySymbol yytoken;
          int yyaction;
          const short int* yyconflicts;

          yystackp->yytops.yylookaheadNeeds[yyk] = yytrue;
          if (yychar == YYEMPTY)
            {
              YYDPRINTF ((stderr, "Reading a token: "));
              yychar = yylex ();
            }

          if (yychar <= YYEOF)
            {
              yychar = yytoken = YYEOF;
              YYDPRINTF ((stderr, "Now at end of input.\n"));
            }
          else
            {
              yytoken = YYTRANSLATE (yychar);
              YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
            }

          yygetLRActions (yystate, yytoken, &yyaction, &yyconflicts);

          while (*yyconflicts != 0)
            {
              YYRESULTTAG yyflag;
              size_t yynewStack = yysplitStack (yystackp, yyk);
              YYDPRINTF ((stderr, "Splitting off stack %lu from %lu.\n",
                          (unsigned long int) yynewStack,
                          (unsigned long int) yyk));
              yyflag = yyglrReduce (yystackp, yynewStack,
                                    *yyconflicts,
                                    yyimmediate[*yyconflicts]);
              if (yyflag == yyok)
                YYCHK (yyprocessOneStack (yystackp, yynewStack,
                                          yyposn));
              else if (yyflag == yyerr)
                {
                  YYDPRINTF ((stderr, "Stack %lu dies.\n",
                              (unsigned long int) yynewStack));
                  yymarkStackDeleted (yystackp, yynewStack);
                }
              else
                return yyflag;
              yyconflicts += 1;
            }

          if (yyisShiftAction (yyaction))
            break;
          else if (yyisErrorAction (yyaction))
            {
              YYDPRINTF ((stderr, "Stack %lu dies.\n",
                          (unsigned long int) yyk));
              yymarkStackDeleted (yystackp, yyk);
              break;
            }
          else
            {
              YYRESULTTAG yyflag = yyglrReduce (yystackp, yyk, -yyaction,
                                                yyimmediate[-yyaction]);
              if (yyflag == yyerr)
                {
                  YYDPRINTF ((stderr,
                              "Stack %lu dies "
                              "(predicate failure or explicit user error).\n",
                              (unsigned long int) yyk));
                  yymarkStackDeleted (yystackp, yyk);
                  break;
                }
              else if (yyflag != yyok)
                return yyflag;
            }
        }
    }
  return yyok;
}

static void
yyreportSyntaxError (yyGLRStack* yystackp)
{
  if (yystackp->yyerrState != 0)
    return;
#if ! YYERROR_VERBOSE
  yyerror (YY_("syntax error"));
#else
  {
  yySymbol yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);
  size_t yysize0 = yytnamerr (YY_NULLPTR, yytokenName (yytoken));
  size_t yysize = yysize0;
  yybool yysize_overflow = yyfalse;
  char* yymsg = YY_NULLPTR;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected").  */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[yystackp->yytops.yystates[0]->yylrState];
      yyarg[yycount++] = yytokenName (yytoken);
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for this
             state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;
          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytokenName (yyx);
                {
                  size_t yysz = yysize + yytnamerr (YY_NULLPTR, yytokenName (yyx));
                  yysize_overflow |= yysz < yysize;
                  yysize = yysz;
                }
              }
        }
    }

  switch (yycount)
    {
#define YYCASE_(N, S)                   \
      case N:                           \
        yyformat = S;                   \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  {
    size_t yysz = yysize + strlen (yyformat);
    yysize_overflow |= yysz < yysize;
    yysize = yysz;
  }

  if (!yysize_overflow)
    yymsg = (char *) YYMALLOC (yysize);

  if (yymsg)
    {
      char *yyp = yymsg;
      int yyi = 0;
      while ((*yyp = *yyformat))
        {
          if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
            {
              yyp += yytnamerr (yyp, yyarg[yyi++]);
              yyformat += 2;
            }
          else
            {
              yyp++;
              yyformat++;
            }
        }
      yyerror (yymsg);
      YYFREE (yymsg);
    }
  else
    {
      yyerror (YY_("syntax error"));
      yyMemoryExhausted (yystackp);
    }
  }
#endif /* YYERROR_VERBOSE */
  yynerrs += 1;
}

/* Recover from a syntax error on *YYSTACKP, assuming that *YYSTACKP->YYTOKENP,
   yylval, and yylloc are the syntactic category, semantic value, and location
   of the lookahead.  */
static void
yyrecoverSyntaxError (yyGLRStack* yystackp)
{
  size_t yyk;
  int yyj;

  if (yystackp->yyerrState == 3)
    /* We just shifted the error token and (perhaps) took some
       reductions.  Skip tokens until we can proceed.  */
    while (yytrue)
      {
        yySymbol yytoken;
        if (yychar == YYEOF)
          yyFail (yystackp, YY_NULLPTR);
        if (yychar != YYEMPTY)
          {
            /* We throw away the lookahead, but the error range
               of the shifted error token must take it into account.  */
            yyGLRState *yys = yystackp->yytops.yystates[0];
            yyGLRStackItem yyerror_range[3];
            yyerror_range[1].yystate.yyloc = yys->yyloc;
            yyerror_range[2].yystate.yyloc = yylloc;
            YYLLOC_DEFAULT ((yys->yyloc), yyerror_range, 2);
            yytoken = YYTRANSLATE (yychar);
            yydestruct ("Error: discarding",
                        yytoken, &yylval, &yylloc);
          }
        YYDPRINTF ((stderr, "Reading a token: "));
        yychar = yylex ();
        if (yychar <= YYEOF)
          {
            yychar = yytoken = YYEOF;
            YYDPRINTF ((stderr, "Now at end of input.\n"));
          }
        else
          {
            yytoken = YYTRANSLATE (yychar);
            YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
          }
        yyj = yypact[yystackp->yytops.yystates[0]->yylrState];
        if (yypact_value_is_default (yyj))
          return;
        yyj += yytoken;
        if (yyj < 0 || YYLAST < yyj || yycheck[yyj] != yytoken)
          {
            if (yydefact[yystackp->yytops.yystates[0]->yylrState] != 0)
              return;
          }
        else if (! yytable_value_is_error (yytable[yyj]))
          return;
      }

  /* Reduce to one stack.  */
  for (yyk = 0; yyk < yystackp->yytops.yysize; yyk += 1)
    if (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
      break;
  if (yyk >= yystackp->yytops.yysize)
    yyFail (yystackp, YY_NULLPTR);
  for (yyk += 1; yyk < yystackp->yytops.yysize; yyk += 1)
    yymarkStackDeleted (yystackp, yyk);
  yyremoveDeletes (yystackp);
  yycompressStack (yystackp);

  /* Now pop stack until we find a state that shifts the error token.  */
  yystackp->yyerrState = 3;
  while (yystackp->yytops.yystates[0] != YY_NULLPTR)
    {
      yyGLRState *yys = yystackp->yytops.yystates[0];
      yyj = yypact[yys->yylrState];
      if (! yypact_value_is_default (yyj))
        {
          yyj += YYTERROR;
          if (0 <= yyj && yyj <= YYLAST && yycheck[yyj] == YYTERROR
              && yyisShiftAction (yytable[yyj]))
            {
              /* Shift the error token.  */
              /* First adjust its location.*/
              YYLTYPE yyerrloc;
              yystackp->yyerror_range[2].yystate.yyloc = yylloc;
              YYLLOC_DEFAULT (yyerrloc, (yystackp->yyerror_range), 2);
              YY_SYMBOL_PRINT ("Shifting", yystos[yytable[yyj]],
                               &yylval, &yyerrloc);
              yyglrShift (yystackp, 0, yytable[yyj],
                          yys->yyposn, &yylval, &yyerrloc);
              yys = yystackp->yytops.yystates[0];
              break;
            }
        }
      yystackp->yyerror_range[1].yystate.yyloc = yys->yyloc;
      if (yys->yypred != YY_NULLPTR)
        yydestroyGLRState ("Error: popping", yys);
      yystackp->yytops.yystates[0] = yys->yypred;
      yystackp->yynextFree -= 1;
      yystackp->yyspaceLeft += 1;
    }
  if (yystackp->yytops.yystates[0] == YY_NULLPTR)
    yyFail (yystackp, YY_NULLPTR);
}

#define YYCHK1(YYE)                                                          \
  do {                                                                       \
    switch (YYE) {                                                           \
    case yyok:                                                               \
      break;                                                                 \
    case yyabort:                                                            \
      goto yyabortlab;                                                       \
    case yyaccept:                                                           \
      goto yyacceptlab;                                                      \
    case yyerr:                                                              \
      goto yyuser_error;                                                     \
    default:                                                                 \
      goto yybuglab;                                                         \
    }                                                                        \
  } while (0)

/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
  int yyresult;
  yyGLRStack yystack;
  yyGLRStack* const yystackp = &yystack;
  size_t yyposn;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY;
  yylval = yyval_default;
  yylloc = yyloc_default;

  if (! yyinitGLRStack (yystackp, YYINITDEPTH))
    goto yyexhaustedlab;
  switch (YYSETJMP (yystack.yyexception_buffer))
    {
    case 0: break;
    case 1: goto yyabortlab;
    case 2: goto yyexhaustedlab;
    default: goto yybuglab;
    }
  yyglrShift (&yystack, 0, 0, 0, &yylval, &yylloc);
  yyposn = 0;

  while (yytrue)
    {
      /* For efficiency, we have two loops, the first of which is
         specialized to deterministic operation (single stack, no
         potential ambiguity).  */
      /* Standard mode */
      while (yytrue)
        {
          yyRuleNum yyrule;
          int yyaction;
          const short int* yyconflicts;

          yyStateNum yystate = yystack.yytops.yystates[0]->yylrState;
          YYDPRINTF ((stderr, "Entering state %d\n", yystate));
          if (yystate == YYFINAL)
            goto yyacceptlab;
          if (yyisDefaultedState (yystate))
            {
              yyrule = yydefaultAction (yystate);
              if (yyrule == 0)
                {
               yystack.yyerror_range[1].yystate.yyloc = yylloc;
                  yyreportSyntaxError (&yystack);
                  goto yyuser_error;
                }
              YYCHK1 (yyglrReduce (&yystack, 0, yyrule, yytrue));
            }
          else
            {
              yySymbol yytoken;
              if (yychar == YYEMPTY)
                {
                  YYDPRINTF ((stderr, "Reading a token: "));
                  yychar = yylex ();
                }

              if (yychar <= YYEOF)
                {
                  yychar = yytoken = YYEOF;
                  YYDPRINTF ((stderr, "Now at end of input.\n"));
                }
              else
                {
                  yytoken = YYTRANSLATE (yychar);
                  YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
                }

              yygetLRActions (yystate, yytoken, &yyaction, &yyconflicts);
              if (*yyconflicts != 0)
                break;
              if (yyisShiftAction (yyaction))
                {
                  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
                  yychar = YYEMPTY;
                  yyposn += 1;
                  yyglrShift (&yystack, 0, yyaction, yyposn, &yylval, &yylloc);
                  if (0 < yystack.yyerrState)
                    yystack.yyerrState -= 1;
                }
              else if (yyisErrorAction (yyaction))
                {
               yystack.yyerror_range[1].yystate.yyloc = yylloc;
                  yyreportSyntaxError (&yystack);
                  goto yyuser_error;
                }
              else
                YYCHK1 (yyglrReduce (&yystack, 0, -yyaction, yytrue));
            }
        }

      while (yytrue)
        {
          yySymbol yytoken_to_shift;
          size_t yys;

          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            yystackp->yytops.yylookaheadNeeds[yys] = yychar != YYEMPTY;

          /* yyprocessOneStack returns one of three things:

              - An error flag.  If the caller is yyprocessOneStack, it
                immediately returns as well.  When the caller is finally
                yyparse, it jumps to an error label via YYCHK1.

              - yyok, but yyprocessOneStack has invoked yymarkStackDeleted
                (&yystack, yys), which sets the top state of yys to NULL.  Thus,
                yyparse's following invocation of yyremoveDeletes will remove
                the stack.

              - yyok, when ready to shift a token.

             Except in the first case, yyparse will invoke yyremoveDeletes and
             then shift the next token onto all remaining stacks.  This
             synchronization of the shift (that is, after all preceding
             reductions on all stacks) helps prevent double destructor calls
             on yylval in the event of memory exhaustion.  */

          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            YYCHK1 (yyprocessOneStack (&yystack, yys, yyposn));
          yyremoveDeletes (&yystack);
          if (yystack.yytops.yysize == 0)
            {
              yyundeleteLastStack (&yystack);
              if (yystack.yytops.yysize == 0)
                yyFail (&yystack, YY_("syntax error"));
              YYCHK1 (yyresolveStack (&yystack));
              YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
           yystack.yyerror_range[1].yystate.yyloc = yylloc;
              yyreportSyntaxError (&yystack);
              goto yyuser_error;
            }

          /* If any yyglrShift call fails, it will fail after shifting.  Thus,
             a copy of yylval will already be on stack 0 in the event of a
             failure in the following loop.  Thus, yychar is set to YYEMPTY
             before the loop to make sure the user destructor for yylval isn't
             called twice.  */
          yytoken_to_shift = YYTRANSLATE (yychar);
          yychar = YYEMPTY;
          yyposn += 1;
          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            {
              int yyaction;
              const short int* yyconflicts;
              yyStateNum yystate = yystack.yytops.yystates[yys]->yylrState;
              yygetLRActions (yystate, yytoken_to_shift, &yyaction,
                              &yyconflicts);
              /* Note that yyconflicts were handled by yyprocessOneStack.  */
              YYDPRINTF ((stderr, "On stack %lu, ", (unsigned long int) yys));
              YY_SYMBOL_PRINT ("shifting", yytoken_to_shift, &yylval, &yylloc);
              yyglrShift (&yystack, yys, yyaction, yyposn,
                          &yylval, &yylloc);
              YYDPRINTF ((stderr, "Stack %lu now in state #%d\n",
                          (unsigned long int) yys,
                          yystack.yytops.yystates[yys]->yylrState));
            }

          if (yystack.yytops.yysize == 1)
            {
              YYCHK1 (yyresolveStack (&yystack));
              YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
              yycompressStack (&yystack);
              break;
            }
        }
      continue;
    yyuser_error:
      yyrecoverSyntaxError (&yystack);
      yyposn = yystack.yytops.yystates[0]->yyposn;
    }

 yyacceptlab:
  yyresult = 0;
  goto yyreturn;

 yybuglab:
  YYASSERT (yyfalse);
  goto yyabortlab;

 yyabortlab:
  yyresult = 1;
  goto yyreturn;

 yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;

 yyreturn:
  if (yychar != YYEMPTY)
    yydestruct ("Cleanup: discarding lookahead",
                YYTRANSLATE (yychar), &yylval, &yylloc);

  /* If the stack is well-formed, pop the stack until it is empty,
     destroying its entries as we go.  But free the stack regardless
     of whether it is well-formed.  */
  if (yystack.yyitems)
    {
      yyGLRState** yystates = yystack.yytops.yystates;
      if (yystates)
        {
          size_t yysize = yystack.yytops.yysize;
          size_t yyk;
          for (yyk = 0; yyk < yysize; yyk += 1)
            if (yystates[yyk])
              {
                while (yystates[yyk])
                  {
                    yyGLRState *yys = yystates[yyk];
                 yystack.yyerror_range[1].yystate.yyloc = yys->yyloc;
                  if (yys->yypred != YY_NULLPTR)
                      yydestroyGLRState ("Cleanup: popping", yys);
                    yystates[yyk] = yys->yypred;
                    yystack.yynextFree -= 1;
                    yystack.yyspaceLeft += 1;
                  }
                break;
              }
        }
      yyfreeGLRStack (&yystack);
    }

  return yyresult;
}

/* DEBUGGING ONLY */
#if YYDEBUG
static void
yy_yypstack (yyGLRState* yys)
{
  if (yys->yypred)
    {
      yy_yypstack (yys->yypred);
      YYFPRINTF (stderr, " -> ");
    }
  YYFPRINTF (stderr, "%d@%lu", yys->yylrState,
             (unsigned long int) yys->yyposn);
}

static void
yypstates (yyGLRState* yyst)
{
  if (yyst == YY_NULLPTR)
    YYFPRINTF (stderr, "<null>");
  else
    yy_yypstack (yyst);
  YYFPRINTF (stderr, "\n");
}

static void
yypstack (yyGLRStack* yystackp, size_t yyk)
{
  yypstates (yystackp->yytops.yystates[yyk]);
}

#define YYINDEX(YYX)                                                         \
    ((YYX) == YY_NULLPTR ? -1 : (yyGLRStackItem*) (YYX) - yystackp->yyitems)


static void
yypdumpstack (yyGLRStack* yystackp)
{
  yyGLRStackItem* yyp;
  size_t yyi;
  for (yyp = yystackp->yyitems; yyp < yystackp->yynextFree; yyp += 1)
    {
      YYFPRINTF (stderr, "%3lu. ",
                 (unsigned long int) (yyp - yystackp->yyitems));
      if (*(yybool *) yyp)
        {
          YYASSERT (yyp->yystate.yyisState);
          YYASSERT (yyp->yyoption.yyisState);
          YYFPRINTF (stderr, "Res: %d, LR State: %d, posn: %lu, pred: %ld",
                     yyp->yystate.yyresolved, yyp->yystate.yylrState,
                     (unsigned long int) yyp->yystate.yyposn,
                     (long int) YYINDEX (yyp->yystate.yypred));
          if (! yyp->yystate.yyresolved)
            YYFPRINTF (stderr, ", firstVal: %ld",
                       (long int) YYINDEX (yyp->yystate
                                             .yysemantics.yyfirstVal));
        }
      else
        {
          YYASSERT (!yyp->yystate.yyisState);
          YYASSERT (!yyp->yyoption.yyisState);
          YYFPRINTF (stderr, "Option. rule: %d, state: %ld, next: %ld",
                     yyp->yyoption.yyrule - 1,
                     (long int) YYINDEX (yyp->yyoption.yystate),
                     (long int) YYINDEX (yyp->yyoption.yynext));
        }
      YYFPRINTF (stderr, "\n");
    }
  YYFPRINTF (stderr, "Tops:");
  for (yyi = 0; yyi < yystackp->yytops.yysize; yyi += 1)
    YYFPRINTF (stderr, "%lu: %ld; ", (unsigned long int) yyi,
               (long int) YYINDEX (yystackp->yytops.yystates[yyi]));
  YYFPRINTF (stderr, "\n");
}
#endif

#undef yylval
#undef yychar
#undef yynerrs
#undef yylloc



#line 840 "src/parser.ypp" /* glr.c:2584  */

